<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2007 The Cacti Group                                      |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/


chdir('../../');

include("./include/auth.php");

include_once($config['base_path'] . '/plugins/configstore/functions.php');
include_once($config['base_path'] . '/plugins/configstore/include/logger.class.php');

global $log;
$log = new Logging();

$account_actions = array(
	1 => "Delete",
	2 => "Duplicate",
);

$action = "";
if (isset($_POST['action'])) {
	$action = $_POST['action'];
} else if (isset($_GET['action'])) {
	$action = $_GET['action'];
}

$account_edit = array (
        "name" => array(
                "method" => "textbox",
                "friendly_name" => "Name",
                "description" => "Give this account a meaningful name that will be displayed.",
                "value" => "|arg1:name|",
                "max_length" => "64"
                ),
        "backup_protocol" => array(
                "method" => "drop_array",
                "friendly_name" => "Backup Protocol",
                "description" => "Choose the transfer protocol used, to send the configuration from the device to the backup server.",
		"on_change" => "changeBackupProtocol()",
                "value" => "|arg1:backup_protocol|",
                "default" => 0,
                "array" => array(1 => 'TFTP (default)', 2 => 'SCP Client (secure)', 3 => 'SCP Server (secure)'),
                ),
	"account_type" => array(
		"method" => "drop_array",
		"friendly_name" => "Account Type",
		"description" => "Choose the type of authentication account you want to create.",
		"on_change" => "changeBackupProtocol()",
		"value" => "|arg1:account_type|",
		"array" => array(0 => "None", 1 => "SNMP v1", 2 => "SNMP v2", 3 => "SNMP v3", 4 => "Telnet", 5 => "SSH")
		),
        "snmp_writestring" => array(
                "method" => "textbox_password",
                "friendly_name" => "SNMP Community String",
                "description" => "Fill in the SNMP write community for this device.",
                "value" => "|arg1:snmp_writestring|",
                "max_length" => "100",
                "size" => "20"
                ),
        "snmp_port" => array(
                "method" => "textbox",
                "friendly_name" => "SNMP Port",
                "description" => "The UDP/TCP Port to poll the SNMP agent on.",
                "value" => "|arg1:snmp_port|",
                "max_length" => "8",
                "size" => "10",
		"default" => "161"
                ),
        "snmp_timeout" => array(
                "method" => "textbox",
                "friendly_name" => "SNMP Timeout",
                "description" => "The maximum number of milliseconds Cacti will wait for an SNMP response (does not work with php-snmp support).",
                "value" => "|arg1:snmp_timeout|",
                "max_length" => "8",
                "size" => "10",
		"default" => "500"
                ),
        "snmp_retries" => array(
                "method" => "textbox",
                "friendly_name" => "SNMP Retries",
                "description" => "The maximum number of attempts to reach a device via an SNMP writestring prior to giving up.",
                "value" => "|arg1:snmp_retries|",
                "max_length" => "8",
                "size" => "10",
		"default" => "3"
                ),
        "snmp_username" => array(
                "method" => "textbox",
                "friendly_name" => "SNMP Username (v3)",
                "description" => "SNMP v3 username for this device.",
                "value" => "|arg1:snmp_username|",
                "max_length" => "50",
                "size" => "15"
                ),
        "snmp_password" => array(
                "method" => "textbox_password",
                "friendly_name" => "SNMP Password (v3)",
                "description" => "SNMP v3 password for this device.",
                "value" => "|arg1:snmp_password|",
                "max_length" => "50",
                "size" => "15"
                ),
        "snmp_auth_protocol" => array(
                "method" => "drop_array",
                "friendly_name" => "SNMP Auth Protocol (v3)",
                "description" => "Choose the SNMP v3 Authorization Protocol.",
                "value" => "|arg1:snmp_auth_protocol|",
                "array" => array("MD5" => "MD5 (default)", "SHA" => "SHA"),
                ),
        "snmp_priv_passphrase" => array(
                "method" => "textbox_password",
                "friendly_name" => "SNMP Privacy Passphrase (v3)",
                "description" => "SNMP v3 Privacy Passphrase for this device.",
                "value" => "|arg1:snmp_priv_passphrase|",
                "max_length" => "200",
                "size" => "40"
                ),
        "snmp_priv_protocol" => array(
                "method" => "drop_array",
                "friendly_name" => "SNMP Privacy Protocol (v3)",
                "description" => "Choose the SNMPv3 Privacy Protocol.",
                "value" => "|arg1:snmp_priv_protocol|",
                "array" => array("[None]" => "[None]", "DES" => "DES", "AES128" => "AES"),
                ),
        "snmp_context" => array(
                "method" => "textbox",
                "friendly_name" => "SNMP Context",
                "description" => "Enter the SNMP Context to use for this device.",
                "value" => "|arg1:snmp_context|",
                "max_length" => "64",
                "size" => "25"
                ),
        "username" => array(
                "method" => "textbox",
                "friendly_name" => "Username",
                "description" => "The username that will be used for authentication.",
                "value" => "|arg1:username|",
                "max_length" => "64",
                ),
        "password" => array(
                "method" => "textbox_password",
                "friendly_name" => "Password",
                "description" => "The password used for authentication.",
                "value" => "|arg1:password|",
                "max_length" => "64",
                "size" => "30"
                ),
        "enablepw" => array(
                "method" => "textbox_password",
                "friendly_name" => "Enable Password",
                "description" => "Your Enable Password, if required.",
                "value" => "|arg1:enablepw|",
                "max_length" => "64",
                "size" => "30"
                ),
        "private_key_path" => array(
                "method" => "filepath",
                "friendly_name" => "Private Key Path",
                "description" => "The path to the private key used for SSH authentication.",
                "value" => "|arg1:private_key_path|",
                "max_length" => "128",
                "size" => "40"
                ),
        "id" => array(
                "method" => "hidden_zero",
                "value" => "|arg1:id|"
                ),
        "action" => array(
                "method" => "hidden_zero",
                "value" => "edit"
                )
        );

switch ($action) {
	case 'actions':
		actions_accounts();
		break;
	case 'save':
		save_accounts ();
		break;
	case 'edit':
		include_once("./include/top_header.php");
		display_tabs ();
		edit_accounts();
		include_once("./include/bottom_footer.php");
		break;
	default:
		include_once("./include/top_header.php");
		display_tabs ();
		show_accounts ();
		include_once("./include/bottom_footer.php");
		break;
}

function display_tabs () {
        /* draw the categories tabs on the top of the page */
        print "<table class='tabs' width='100%' cellspacing='0' cellpadding='3' align='center'><tr>\n";
        print "<td bgcolor='#DFDFDF' nowrap='nowrap' width='" . (strlen('Sites') * 9) . "' align='center' class='tab'>
                        <span class='textHeader'><a href='configstore_sites.php'>Sites</a></span>
                        </td>\n
                        <td width='1'></td>\n";
        print "<td bgcolor='#DFDFDF' nowrap='nowrap' width='" . (strlen('Devices') * 9) . "' align='center' class='tab'>
                        <span class='textHeader'><a href='configstore_devices.php'>Devices</a></span>
                        </td>\n
                        <td width='1'></td>\n";
        print "<td bgcolor='#DFDFDF' nowrap='nowrap' width='" . (strlen('Backups') * 9) . "' align='center' class='tab'>
                        <span class='textHeader'><a href='configstore_backups.php?device='>Backups</a></span>
                        </td>\n
                        <td width='1'></td>\n";
        print "<td bgcolor='silver' nowrap='nowrap' width='" . (strlen('Accounts') * 9) . "' align='center' class='tab'>
                        <span class='textHeader'><a href='configstore_accounts.php'>Accounts</a></span>
                        </td>\n
                        <td width='1'></td>\n";
        print "<td bgcolor='#DFDFDF' nowrap='nowrap' width='" . (strlen('Compare') * 9) . "' align='center' class='tab'>
                        <span class='textHeader'><a href='configstore_compare.php'>Compare</a></span>
                        </td>\n
                        <td width='1'></td>\n";
        print "<td></td>\n</tr></table>\n";
}

function actions_accounts () {
	global $colors, $account_actions, $config;
	if (isset($_POST["selected_items"])) {
		$selected_items = unserialize(stripslashes($_POST["selected_items"]));
		if ($_POST["drp_action"] == "1") { /* delete */

			for ($i=0; $i<count($selected_items); $i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */
				db_execute("DELETE FROM plugin_configstore_accounts WHERE id = " . $selected_items[$i]);
			}
		} elseif ($_POST["drp_action"] == "2") { /* duplicate */
                        for ($i=0;($i<count($selected_items));$i++) {
                                /* ================= input validation ================= */
                                input_validate_input_number($selected_items[$i]);
                                /* ==================================================== */

                                duplicate_account($selected_items[$i], $i, $_POST["title_format"]);
                        }
                }

		header("Location: configstore_accounts.php");
		exit;
	}


	/* setup some variables */
	$account_list = "";
	$i = 0;

	/* loop through each of the accounts selected on the previous page and get more info about them */
	while (list($var,$val) = each($_POST)) {
		if (ereg("^chk_([0-9]+)$", $var, $matches)) {
			/* ================= input validation ================= */
			input_validate_input_number($matches[1]);
			/* ==================================================== */

			$account_list .= "<li>" . db_fetch_cell("SELECT name FROM plugin_configstore_accounts WHERE id=" . $matches[1]) . "<br>";
			$account_array[$i] = $matches[1];
		}
		$i++;
	}

	include_once("./include/top_header.php");

	html_start_box("<strong>" . $account_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "3", "center", "");

	print "<form action='configstore_accounts.php' method='post'>\n";

	if ($_POST["drp_action"] == "1") { /* Delete */
		print "	<tr>
				<td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
					<p>To delete the following accounts, press the \"yes\" button below.</p>
					<p><ul>$account_list</ul></p>
				</td>
				</tr>";
	} elseif ($_POST["drp_action"] == "2") { /* duplicate */
                print " <tr>
                                <td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
                                        <p>When you click save, the following accounts will be duplicated. You may optionally change the description for the new account.  Otherwise, do not change value below and the original name will be replicated with a new suffix.</p>
                                        <p><ul>$account_list</ul></p>
                                        <p><strong>Account Prefix:</strong><br>"; form_text_box("title_format", "<name> (1)", "", "255", "30", "text"); print "</p>
                                </td>
                        </tr>\n
             ";
        }

	if (!isset($account_list)) {
                print "<tr><td bgcolor='#" . $colors["form_alternate1"]. "'><span class='textError'>You must select at least one account.</span></td></tr>\n";
                $save_html = "";
        }else{
		$save_html = "<input type='image' src='" . $config['url_path'] . "images/button_yes.gif' alt='Save' align='absmiddle'>";
        }

        print " <tr>
                        <td colspan='2' align='right' bgcolor='#eaeaea'>
                                <input type='hidden' name='action' value='actions'>
                                <input type='hidden' name='selected_items' value='" . (isset($account_array) ? serialize($account_array) : '') . "'>
                                <input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
                                <a href='configstore_accounts.php'><img src='" . $config['url_path'] . "images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
                                $save_html
                        </td>
                </tr>
        ";

        html_end_box();

        include_once("./include/bottom_footer.php");
}

function save_accounts() {
	global $log;
	/* ================= input validation ================= */
        input_validate_input_number(get_request_var_post("id"));
        /* ==================================================== */

        if (isset($_POST['id'])) {
		$id = $_POST["id"];
        } else {
                $id = '';
        }

	$account_type = $_POST["account_type"];
	$backup_protocol = $_POST["backup_protocol"];
	$name = $_POST["name"];

	if ( ($backup_protocol != "3") && ($account_type == "0") || (!isset($_POST["id"])) ) {
		raise_message(2);
	} elseif ( ($backup_protocol == "3") && ($account_type != "0") || (!isset($_POST["id"])) ) {
		raise_message(2);
	}
 
	if ($account_type == ("1") || ("2")) {
		$save["id"] = $id;
		$save["name"] = $name;
		$save["account_type"] = $account_type;
		$save["backup_protocol"] = $backup_protocol;
		if ($account_type == "1") { $save["snmp_version"] = "1"; }
		if ($account_type == "2") { $save["snmp_version"] = "2c"; }

		if (isset($_POST["snmp_writestring"])) {
			$save["snmp_writestring"] = plugin_configstore_encode($_POST["snmp_writestring"]);
		} else {
			raise_message(4);
		}

		if (isset($_POST["snmp_port"])) {
			$save["snmp_port"] = sql_sanitize($_POST["snmp_port"]);
		} else {
			raise_message(4);
		}

                if (isset($_POST["snmp_timeout"])) {
                        $save["snmp_timeout"] = sql_sanitize($_POST["snmp_timeout"]);
                } else {
                        raise_message(4);
                }

		if (isset($_POST['snmp_retries'])) {
                        $save['snmp_retries'] = sql_sanitize($_POST['snmp_retries']);
                } else {
                        raise_message(4);
                }
	} 

	if ($account_type == "3") {
                $save["id"] = $id;
                $save["name"] = $name;
                $save["account_type"] = $account_type;
		$save["backup_protocol"] = $backup_protocol;
		$save["snmp_version"] = "3";

		if (isset($_POST['snmp_username'])) {
                        $save['snmp_username'] = sql_sanitize($_POST['snmp_username']);
                } else {
                        raise_message(4);
                }
	
                if (isset($_POST['snmp_password'])) {
			if ($_POST['snmp_password'] == $_POST['snmp_password_confirm']) {
				if ($_POST['snmp_password'] != '') {
					$save['snmp_password'] = plugin_configstore_encode($_POST['snmp_password']);
				}
			} elseif ($save['id'] < 1) {
				raise_message(4);
			} else {
                                // passwords are not the same!
                                raise_message(4);
                        }
                } else {
			// passwords are not the same!
                        raise_message(4);
                }

		if (isset($_POST['snmp_auth_protocol'])) {
                        $save['snmp_auth_protocol'] = sql_sanitize($_POST['snmp_auth_protocol']);
                } else {
                        raise_message(4);
                }

		if (isset($_POST['snmp_priv_passphrase'])) {
                        $save['snmp_priv_passphrase'] = plugin_configstore_encode($_POST['snmp_priv_passphrase']);
                } else {
                        raise_message(4);
                }

                if (isset($_POST['snmp_priv_protocol'])) {
                        $save['snmp_priv_protocol'] = sql_sanitize($_POST['snmp_priv_protocol']);
                } else {
                        raise_message(4);
                }

		if (isset($_POST['snmp_context'])) {
                        $save['snmp_context'] = sql_sanitize($_POST['snmp_context']);
                } else {
                        raise_message(4);
                }

                if (isset($_POST['snmp_port'])) {
                        $save['snmp_port'] = sql_sanitize($_POST['snmp_port']);
                } else {
                        raise_message(4);
                }

                if (isset($_POST['snmp_timeout'])) {
                        $save['snmp_timeout'] = sql_sanitize($_POST['snmp_timeout']);
                } else {
                        raise_message(4);
                }

                if (isset($_POST['snmp_retries'])) {
                        $save['snmp_retries'] = sql_sanitize($_POST['snmp_retries']);
                } else {
                        raise_message(4);
                }
	} 

	if ($account_type == "4") {
                $save["id"] = $id;
                $save["name"] = $name;
                $save["account_type"] = $account_type;
		$save["backup_protocol"] = $backup_protocol;

                if (isset($_POST['username'])) {
                        $save["username"] = sql_sanitize($_POST['username']);
                } else {
                        raise_message(4);
                }

                if (isset($_POST['password'])) {
                        if ( ($_POST['password'] != '') && ($_POST['password'] == $_POST['password_confirm']) ) {
                        	$save['password'] = plugin_configstore_encode($_POST['password']);
                        } else {
                                // passwords are not the same!
                                raise_message(4);
                        }
                } else {
                        raise_message(4);
                }

                if (isset($_POST['enablepw'])) {
                        if ($_POST['enablepw'] == $_POST['enablepw_confirm']) {
                                if ($_POST['enablepw'] != '') {
                                        $save['enablepw'] = plugin_configstore_encode($_POST['enablepw']);
                                }
                        } elseif ($save['id'] < 1) {
                                raise_message(4);
                        } else {
				// passwords are not the same!
				raise_message(4);
			}
                }
        } 

	if ($account_type == "5") {
                $save["id"] = $id;
                $save["name"] = $name;
                $save["account_type"] = $account_type;
		$save["backup_protocol"] = $backup_protocol;

                if (isset($_POST['username'])) {
                        $save['username'] = sql_sanitize($_POST['username']);
                } else {
                        raise_message(4);
                }

                if (isset($_POST['password'])) {
                        if ($_POST['password'] == $_POST['password_confirm']) {
                                if ($_POST['password'] != '') {
                                        $save['password'] = plugin_configstore_encode($_POST['password']);
                                }
                        } elseif ($save['id'] < 1) {
                                raise_message(4);
                        } else {
                                // passwords are not the same!
                                raise_message(4);
                        }
                } else {
                        raise_message(4);
                }

                if (isset($_POST['enablepw'])) {
                        if ($_POST['enablepw'] == $_POST['enablepw']) {
                                if ($_POST['enablepw'] != '') {
                                        $save['enablepw'] = plugin_configstore_encode($_POST['enablepw']);
                                }
                        } elseif ($save['id'] < 1) {
                                raise_message(4);
                        } else {
                                // passwords are not the same!
                                raise_message(4);
                        }
                }

                if (isset($_POST['private_key_path'])) {
                        $save['private_key_path'] = sql_sanitize($_POST['private_key_path']);
                }

	}

	if ( ($backup_protocol == "3") && ($account_type == "0") ) {
		$save["id"] = $id;
                $save["name"] = $name;
		$save['account_type'] = $account_type;
		$save["backup_protocol"] = $backup_protocol;

		if (isset($_POST['username'])) {
                        $save['username'] = sql_sanitize($_POST['username']);
                } else {
                        raise_message(4);
                }

                if (isset($_POST['password'])) {
                        if ($_POST['password'] == $_POST['password_confirm']) {
                                if ($_POST['password'] != '') {
                                        $save['password'] = plugin_configstore_encode($_POST['password']);
                                }
                        } elseif ($save['id'] < 1) {
                                raise_message(4);
                        } else {
                                // passwords are not the same!
                                raise_message(4);
                        }
                } else {
                        raise_message(4);
                }
	}

	$id = sql_save($save, "plugin_configstore_accounts", "id");

	if (is_error_message()) {
		header ("Location: configstore_accounts.php?action=edit&id=" . (empty($id) ? $_POST["id"] : $id));
		exit;
	}
	header("Location: configstore_accounts.php");
	exit;
}

function edit_accounts () {
	global $account_edit, $colors;

        /* ================= input validation ================= */
        input_validate_input_number(get_request_var_post("id"));
        /* ==================================================== */

        # fetch the current account record
	$account = array();
	if (!empty($_GET["id"])) {
        	$account = db_fetch_row("SELECT * FROM plugin_configstore_accounts WHERE id=" . $_GET["id"], FALSE);
		$header_label = "[edit: " . $account["name"] . "]";

		if (isset($account['password'])) {
			$account['password'] = plugin_configstore_decode($account['password']);
		}
		if (isset($account['enablepw'])) {
			$account['enablepw'] = plugin_configstore_decode($account['enablepw']);
                }
                if (isset($account['snmp_writestring'])) {
                	$account['snmp_writestring'] = plugin_configstore_decode($account['snmp_writestring']);
                }
                if (isset($_POST['snmp_password'])) {
                	$account['snmp_password'] = plugin_configstore_decode($account['snmp_password']);
                }
                if (isset($account['snmp_priv_passphrase'])) {
                	$account['snmp_priv_passphrase'] = plugin_configstore_decode($account['snmp_priv_passphrase']);
                }
	} else {
		$header_label = "[new]";
	}

	html_start_box("<strong>Account:</strong> $header_label", "100%", $colors["header"], "3", "center", "");
	draw_edit_form(array(
		"config" => array("form_name" => "chk"),
		"fields" => inject_form_variables($account_edit, $account)
		)
	);

	html_end_box();
	form_save_button("configstore_accounts.php");
        print "<script type='text/javascript' src='" . URL_PATH . "plugins/configstore/configstore_accounts.js'></script>";
        print "<script type='text/javascript' src='" . URL_PATH . "plugins/configstore/jquery.js'></script>";
}

function show_accounts () {
	global $action, $host, $command;
	global $colors, $config, $account_actions;

        /* clean up sort_column */
        if (isset($_REQUEST["sort_column"])) {
                $_REQUEST["sort_column"] = sanitize_search_string(get_request_var("sort_column"));
        }

        /* clean up search string */
        if (isset($_REQUEST["sort_direction"])) {
                $_REQUEST["sort_direction"] = sanitize_search_string(get_request_var("sort_direction"));
        }

        /* remember these search fields in session vars so we don't have to keep passing them around */
	load_current_session_value("page", "sess_configstore_accounts_current_page", "1");
	load_current_session_value("rows", "sess_configstore_accounts_rows", "-1");
	load_current_session_value("sort_column", "sess_configstore_accounts_sort_column", "hostname");
	load_current_session_value("sort_direction", "sess_configstore_accounts_sort_direction", "ASC");


        if ($_REQUEST["rows"] == -1) {
                $num_rows = 30;
        }elseif ($_REQUEST["rows"] == -2) {
                $num_rows = 999999;
        }else{
                $num_rows = $_REQUEST["rows"];
        }

	$sql = "SELECT * FROM plugin_configstore_accounts limit " . ($num_rows*($_REQUEST["page"]-1)) . ", $num_rows";

	$result = db_fetch_assoc($sql);

	define("MAX_DISPLAY_PAGES", 21);
	$total_rows = db_fetch_cell("SELECT COUNT(*) FROM plugin_configstore_accounts");
	$url_page_select = get_page_list($_REQUEST["page"], MAX_DISPLAY_PAGES, $num_rows, $total_rows, "configstore_accounts.php?");

	html_start_box("", "100%", $colors["header"], "4", "center", "");
	$nav = "<tr bgcolor='#" . $colors["header"] . "'>
			<td colspan='10'>
				<table width='100%' cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td align='left' class='textHeaderDark'>
							<strong>&lt;&lt; "; if ($_REQUEST["page"] > 1) { $nav .= "<a class='linkOverDark' href='configstore_accounts.php?page=" . ($_REQUEST["page"]-1) . "'>"; } $nav .= "Previous"; if ($_REQUEST["page"] > 1) { $nav .= "</a>"; } $nav .= "</strong>
						</td>\n
						<td align='center' class='textHeaderDark'>
							Showing Rows " . (($num_rows*($_REQUEST["page"]-1))+1) . " to " . ((($total_rows < $num_rows) || ($total_rows < ($num_rows*$_REQUEST["page"]))) ? $total_rows : ($num_rows*$_REQUEST["page"])) . " of $total_rows [$url_page_select]
						</td>\n
						<td align='right' class='textHeaderDark'>
							<strong>"; if (($_REQUEST["page"] * $num_rows) < $total_rows) { $nav .= "<a class='linkOverDark' href='configstore_accounts.php?page=" . ($_REQUEST["page"]+1) . "'>"; } $nav .= "Next"; if (($_REQUEST["page"] * $num_rows) < $total_rows) { $nav .= "</a>"; } $nav .= " &gt;&gt;</strong>
						</td>\n
					</tr>
				</table>
			</td>
		</tr>\n";

	print $nav;

        $display_text = array(
                "name" => array("Name", "ASC"),
                "account_type" => array("Account Type", "ASC"),
		"backup_protocol" => array("Backup Protocol", "ASC"),
                "count" => array("Devices", "DESC"));

        html_header_sort_checkbox($display_text, $_REQUEST["sort_column"], $_REQUEST["sort_direction"]);

	$i=0;
	foreach ($result as $row) {

                $count = db_fetch_cell("SELECT count(account) FROM plugin_configstore_devices WHERE account = " . $row['id']);

		if ($row["account_type"] == "0") { $account_type = "None"; }
		if ($row["account_type"] == "1") { $account_type = "SNMPv1"; }
		if ($row["account_type"] == "2") { $account_type = "SNMPv2"; }
		if ($row["account_type"] == "3") { $account_type = "SNMPv3"; }
		if ($row["account_type"] == "4") { $account_type = "Telnet"; }
		if ($row["account_type"] == "5") { $account_type = "SSH"; }

		if ($row["backup_protocol"] == "1") { $backup_protocol = "TFTP"; }
		if ($row["backup_protocol"] == "2") { $backup_protocol = "SCP Client"; }
                if ($row["backup_protocol"] == "3") { $backup_protocol = "SCP Server"; }

		form_alternate_row_color($colors["alternate"],$colors["light"],$i, 'line' . $row["id"]); $i++;
		form_selectable_cell('<a href="configstore_accounts.php?&action=edit&id=' . $row['id'] . '">' . $row['name'] . '</a>', $row["id"]);
		form_selectable_cell($account_type, $row["id"]);
		form_selectable_cell($backup_protocol, $row["id"]);
		form_selectable_cell('<a href="configstore_devices.php?account=' . $row['id'] . '">' . $count . '</a>', $row["id"]);
                form_checkbox_cell($row["hostname"], $row["id"]);
                form_end_row();
	}
	print $nav;

	html_end_box(false);
	draw_actions_dropdown($account_actions);

	print "&nbsp;&nbsp;&nbsp;<a href='configstore_accounts.php?action=edit'><img border=0 src='" . $config['url_path'] . "images/button_add.gif'></a>";

}

function duplicate_account ($id, $dup_id, $name) {
        if (!empty($id)) {
                $account = db_fetch_row("SELECT * FROM plugin_configstore_accounts WHERE id=$id");

                /* create new account */
                $save["id"] = 0;

                if (substr_count($name, "<name>")) {
                        $save["name"] = $account["name"] . "(1)";
                }else{
                        $save["name"] = $name . "(" . $dup_id . ")";
                }

                $save["account_type"] = $account["account_type"];
		$save["backup_protocol"] = $account["backup_protocol"];
                $save["snmp_writestring"] = $account["snmp_writestring"];
                $save["snmp_port"] = $account["snmp_port"];
		$save["snmp_timeout"] = $account["snmp_timeout"];
		$save["snmp_retries"] = $account["snmp_retries"];
		$save["snmp_username"] = $account["snmp_username"];
		$save["snmp_password"] = $account["snmp_password"];
		$save["snmp_auth_protocol"] = $account["snmp_auth_protocol"];
		$save["snmp_priv_passphrase"] = $account["snmp_priv_passphrase"];
		$save["snmp_context"] = $account["snmp_context"];
		$save["username"] = $account["username"];
		$save["password"] = $account["password"];
		$save["enablepw"] = $account["enablepw"];
		$save["private_key_path"] = $account["private_key_path"];

                $id = sql_save($save, "plugin_configstore_accounts", array("id"));
        }
}
