<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2007 The Cacti Group                                      |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/


chdir('../../');

include("./include/auth.php");

include_once($config['base_path'] . '/plugins/configstore/functions.php');
include_once($config['base_path'] . '/plugins/configstore/include/logger.class.php');

global $log;
$log = new Logging();

$action = "";
if (isset($_POST['action'])) {
	$action = $_POST['action'];
} else if (isset($_GET['action'])) {
	$action = $_GET['action'];
}

switch ($action) {
	case 'viewconfig':
		view_archived_config();
		break;
	default:
		include_once("./include/top_header.php");
		show_archive ();
		include_once("./include/bottom_footer.php");
		break;
}

function view_archived_config() {
	global $colors;
	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("id"));
	/* ==================================================== */

	$archive = array();
	if (!empty($_GET["id"])) {
		$archive = db_fetch_row("SELECT * FROM plugin_configstore_archive WHERE id=" . $_GET["id"], FALSE);
	}

	if (isset($archive['id'])) {
		include_once("./include/top_header.php");
		html_start_box("", "98%", $colors["header"], "4", "center", "");
		form_alternate_row_color($colors["alternate"],$colors["light"],0);
		print '<td><h2>Config for ' . $archive['device_hostname'] . ' (' . $archive['device_ipaddress'] . ')<br><br>';
		print 'Backup from ' . date('M j Y H:i:s', $archive['btime']) . '<br>';
		print 'File: ' . $archive['filename'];
		print '</h1><textarea rows=36 cols=120>';
		print $archive['config'];
		print '</textarea></td></tr>';
		html_end_box(false);
	} else {
		header("Location: configstore_archive.php");
		exit;
	}
}

function configstore_get_archive(&$sql_where, $num_rows, $apply_limits = TRUE) {
	global $log;

	if ( (isset($_REQUEST['filter'])) && ($_REQUEST['filter'] != '') ) {
                $sql_where = " WHERE (plugin_configstore_archive.filename LIKE '%%" . $_REQUEST['filter'] . "%%' OR
                        plugin_configstore_archive.device_hostname LIKE '%%" . $_REQUEST['filter'] . "%%' OR plugin_configstore_archive.device_ipaddress LIKE '%%" . $_REQUEST['filter'] . "%%')";
        } 
	
	$query_string = " SELECT * FROM plugin_configstore_archive
                $sql_where
                ORDER BY " . $_REQUEST["sort_column"] . " " . $_REQUEST["sort_direction"];

        if ($apply_limits) {
                $query_string .= " LIMIT " . ($num_rows*($_REQUEST["page"]-1)) . "," . $num_rows;
        }

        return db_fetch_assoc($query_string);
}

function show_archive () {
	global $action, $colors, $config, $result;

        /* ================= input validation ================= */
        input_validate_input_number(get_request_var_request("page"));
        input_validate_input_number(get_request_var_request("rows"));
        /* ==================================================== */

        /* clean up search filter */
        if (isset($_REQUEST["filter"])) {
                $_REQUEST["filter"] = sanitize_search_string(get_request_var("filter"));
        }

        /* clean up sort_column */
        if (isset($_REQUEST["sort_column"])) {
                $_REQUEST["sort_column"] = sanitize_search_string(get_request_var("sort_column"));
        }

        /* clean up search string */
        if (isset($_REQUEST["sort_direction"])) {
                $_REQUEST["sort_direction"] = sanitize_search_string(get_request_var("sort_direction"));
        }

        /* if the user pushed the 'clear' button */
        if (isset($_REQUEST["clear_x"])) {
                kill_session_var("sess_configstore_archive_current_page");
                kill_session_var("sess_configstore_archive_filter");
                kill_session_var("sess_configstore_archive_rows");
                kill_session_var("sess_configstore_archive_sort_column");
                kill_session_var("sess_configstore_archive_sort_direction");

                unset($_REQUEST["page"]);
                unset($_REQUEST["filter"]);
                unset($_REQUEST["rows"]);
                unset($_REQUEST["sort_column"]);
                unset($_REQUEST["sort_direction"]);
        }

        /* remember these search fields in session vars so we don't have to keep passing them around */
        load_current_session_value("page", "sess_configstore_archive_current_page", "1");
        load_current_session_value("filter", "sess_configstore_archive_filter", "");
        load_current_session_value("rows", "sess_configstore_archive_rows", "-1");
        load_current_session_value("sort_column", "sess_configstore_archive_sort_column", "device_hostname");
        load_current_session_value("sort_direction", "sess_configstore_archive_sort_direction", "ASC");

        if ($_REQUEST["rows"] == -1) {
                $num_rows = 30;
        }elseif ($_REQUEST["rows"] == -2) {
                $num_rows = 999999;
        }else{
                $num_rows = $_REQUEST["rows"];
        }

	define("MAX_DISPLAY_PAGES", 21);
	$total_rows = db_fetch_cell("SELECT COUNT(*) FROM plugin_configstore_archive");
	$url_page_select = get_page_list($_REQUEST["page"], MAX_DISPLAY_PAGES, $num_rows, $total_rows, "configstore_archive.php?");

        // START Archive filter
        html_start_box("<strong>Configstore Archive Filter</strong>", "98%", $colors["header"], "3", "center", "");
        configstore_generic_filter(); //same function as backups, why recreate the wheel..
        html_end_box();
        // END Archive filter

        $sql_where = "";
        $result = configstore_get_archive($sql_where, $num_rows);

	html_start_box("", "98%", $colors["header"], "4", "center", "");
	$nav = "<tr bgcolor='#" . $colors["header"] . "'>
			<td colspan='10'>
				<table width='100%' cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td align='left' class='textHeaderDark'>
							<strong>&lt;&lt; "; if ($_REQUEST["page"] > 1) { $nav .= "<a class='linkOverDark' href='configstore_archive.php?page=" . ($_REQUEST["page"]-1) . "'>"; } $nav .= "Previous"; if ($_REQUEST["page"] > 1) { $nav .= "</a>"; } $nav .= "</strong>
						</td>\n
						<td align='center' class='textHeaderDark'>
							Showing Rows " . (($num_rows*($_REQUEST["page"]-1))+1) . " to " . ((($total_rows < $num_rows) || ($total_rows < ($num_rows*$_REQUEST["page"]))) ? $total_rows : ($num_rows*$_REQUEST["page"])) . " of $total_rows [$url_page_select]
						</td>\n
						<td align='right' class='textHeaderDark'>
							<strong>"; if (($_REQUEST["page"] * $num_rows) < $total_rows) { $nav .= "<a class='linkOverDark' href='configstore_archive.php?page=" . ($_REQUEST["page"]+1) . "'>"; } $nav .= "Next"; if (($_REQUEST["page"] * $num_rows) < $total_rows) { $nav .= "</a>"; } $nav .= " &gt;&gt;</strong>
						</td>\n
					</tr>
				</table>
			</td>
		</tr>\n";

	print $nav;

	$display_text = array(
		"device_hostname" => array("Hostname", "ASC"),
		"device_ipaddress" => array("IP Address", "DESC"),
		"view" => array(" ", " "),
		"filename" => array("Filename", "ASC"),
		"btime" => array("Backup Time", "DESC"),
		"lastchange" => array("Last Change", "DESC"),
		"username" => array("Changed By", "ASC"),
		"atime" => array("Archived Time", "DESC"));

	html_header_sort($display_text, $_REQUEST["sort_column"], $_REQUEST["sort_direction"]);
		

	$r = db_fetch_assoc("SELECT device_hostname, id FROM plugin_configstore_archive ORDER BY btime ASC");
	$latest = array();
	if (count($r)) {
		foreach ($r as $s) {
			$latest[$s['device_hostname']] = $s['id'];
		}
	}
	$c=0;
	$i=0;
	foreach ($result as $row) {
		form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
		print '<td>' . $row['device_hostname'] . '</td>';
		print '<td>' . $row['device_ipaddress'] . '</td>';
		print "<td><a href='configstore_archive.php?action=viewconfig&id=" . $row['id'] . "'>View Config</a></td>";
		print '<td>' . $row['filename'] . '</td>';
		print '<td>' . date('M j Y H:i:s', $row['btime']) . '</td>';
		if ($row['lastchange'] > 0) {
			print '<td>' . date('M j Y H:i:s', $row['lastchange']) . '</td>';
		} else {
			print '<td> </td>';
		}
		print '<td>' . $row['username'] . '</td>';
		print '<td>' . date('M j Y H:i:s', $row['atime']) . '</td>';

		print "</tr>";
	}
	print $nav;

        html_end_box(false);
}
