<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2007 The Cacti Group                                      |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/


chdir('../../');

include("./include/auth.php");

include_once($config['base_path'] . '/plugins/configstore/functions.php');
include_once($config['base_path'] . '/plugins/configstore/include/logger.class.php');

global $log;
$log = new Logging();


$backup_actions = array(1 => 'Delete');

$action = "";
if (isset($_POST['action'])) {
	$action = $_POST['action'];
} else if (isset($_GET['action'])) {
	$action = $_GET['action'];
}

switch ($action) {
	case 'viewconfig':
		view_device_config();
		break;
	case 'actions':
		actions_backups();
		break;
	default:
		include_once("./include/top_header.php");
		display_tabs ();
		show_backups ();
		include_once("./include/bottom_footer.php");
		break;
}

function display_tabs () {
        /* draw the categories tabs on the top of the page */
        print "<table class='tabs' width='100%' cellspacing='0' cellpadding='3' align='center'><tr>\n";
        print "<td bgcolor='#DFDFDF' nowrap='nowrap' width='" . (strlen('Sites') * 9) . "' align='center' class='tab'>
                        <span class='textHeader'><a href='configstore_sites.php'>Sites</a></span>
                        </td>\n
                        <td width='1'></td>\n";
        print "<td bgcolor='#DFDFDF' nowrap='nowrap' width='" . (strlen('Devices') * 9) . "' align='center' class='tab'>
                        <span class='textHeader'><a href='configstore_devices.php'>Devices</a></span>
                        </td>\n
                        <td width='1'></td>\n";
        print "<td bgcolor='silver' nowrap='nowrap' width='" . (strlen('Backups') * 9) . "' align='center' class='tab'>
                        <span class='textHeader'><a href='configstore_backups.php?device='>Backups</a></span>
                        </td>\n
                        <td width='1'></td>\n";
        print "<td bgcolor='#DFDFDF' nowrap='nowrap' width='" . (strlen('Accounts') * 9) . "' align='center' class='tab'>
                        <span class='textHeader'><a href='configstore_accounts.php'>Accounts</a></span>
                        </td>\n
                        <td width='1'></td>\n";
        print "<td bgcolor='#DFDFDF' nowrap='nowrap' width='" . (strlen('Compare') * 9) . "' align='center' class='tab'>
                        <span class='textHeader'><a href='configstore_compare.php'>Compare</a></span>
                        </td>\n
                        <td width='1'></td>\n";
        print "<td></td>\n</tr></table>\n";
}

function view_device_config() {
	global $colors;
	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("id"));
	input_validate_input_number(get_request_var("device"));
	/* ==================================================== */
	$device = array();
	if (!empty($_GET["id"])) {
		$device = db_fetch_row("SELECT plugin_configstore_backups.*, plugin_configstore_devices.hostname, plugin_configstore_devices.ipaddress
					 FROM plugin_configstore_devices,plugin_configstore_backups
					 WHERE plugin_configstore_backups.device = plugin_configstore_devices.id AND plugin_configstore_backups.id=" . $_GET["id"], FALSE);
	}

	if (isset($device['id'])) {
		include_once("./include/top_header.php");
		display_tabs ();
		html_start_box("", "100%", $colors["header"], "4", "center", "");
		form_alternate_row_color($colors["alternate"],$colors["light"],0);
		print '<td><h2>Config for ' . $device['hostname'] . ' (' . $device['ipaddress'] . ')<br><br>';
		print 'Backup from ' . date('M j Y H:i:s', $device['btime']) . '<br>';
		print 'File: ' . $device['directory'] . '/' . $device['filename'];
		print '</h1><textarea rows=36 cols=120>';
		print $device['config'];
		print '</textarea></td></tr>';
		html_end_box(false);
	} else {
		header("Location: configstore_backups.php");
		exit;
	}
}

function actions_backups () {
        global $colors, $backup_actions, $config, $log;

        if (isset($_POST["selected_items"])) { 
                $selected_items = unserialize(stripslashes($_POST["selected_items"]));
                if ($_POST["drp_action"] == "1") { //Delete and Archive backups
			$archive_results = plugin_configstore_archive_backups ($selected_items);
			if ($archive_results) {
			} else {
			}
                }
                header("Location: configstore_backups.php");
                exit;
        }


        /* setup some variables */
        $backup_list = "";
        $i = 0;

        /* loop through each of the backups selected on the previous page and get more info about them */
        while (list($var,$val) = each($_POST)) {
                if (ereg("^chk_([0-9]+)$", $var, $matches)) {
                        /* ================= input validation ================= */
                        input_validate_input_number($matches[1]);
                        /* ==================================================== */

                        $backup_list .= "<li>" . db_fetch_cell("SELECT filename FROM plugin_configstore_backups WHERE id=" . $matches[1]) . "<br>";
                        $backup_array[$i] = $matches[1];
                }
                $i++;
        }

        include_once("./include/top_header.php");

        html_start_box("<strong>" . $backup_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "3", "center", "");

        print "<form action='configstore_backups.php' method='post'>\n";
        if ($_POST["drp_action"] == "1") { /* Delete and Archive */
                print " <tr>
                                <td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
                                        <p>To delete and archive the following backups, press the \"yes\" button below.</p>
                                        <p><ul>$backup_list</ul></p>
                                </td>
                                </tr>";
        }

        if (!isset($backup_array)) {
                print "<tr><td bgcolor='#" . $colors["form_alternate1"]. "'><span class='textError'>You must select at least one backup.</span></td></tr>\n";
                $save_html = "";
        }else{
                $save_html = "<input type='image' src='" . $config['url_path'] . "images/button_yes.gif' alt='Delete' align='absmiddle'>";
        }

        print " <tr>
                        <td colspan='2' align='right' bgcolor='#eaeaea'>
                                <input type='hidden' name='action' value='actions'>
                                <input type='hidden' name='selected_items' value='" . (isset($backup_array) ? serialize($backup_array) : '') . "'>
                                <input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
                                <a href='configstore_backups.php'><img src='" . $config['url_path'] . "images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
                                $save_html
                        </td>
                </tr>
                ";

        html_end_box();

        include_once("./include/bottom_footer.php");
}

function configstore_get_backups(&$sql_where, $num_rows, $apply_limits = TRUE) {
	global $log;

	$device = '';
        if ( (isset($_REQUEST['device'])) && ($_REQUEST['device'] != '') ) {
                input_validate_input_number(get_request_var("device"));
                $device = $_REQUEST['device'];
                if (isset($_SESSION['sess_configstore_backups_device']) && $_SESSION['sess_configstore_backups_device'] != $device) {
                        $page = 1;
                        $_REQUEST["page"] = 1;
                }
                $_SESSION['sess_configstore_backups_device'] = $device;
        } elseif (isset($_SESSION['sess_configstore_backups_device']) && $_SESSION['sess_configstore_backups_device'] != '') {
                $device = $_SESSION['sess_configstore_backups_device'];
	}

	if ( (isset($_REQUEST['filter'])) && ($_REQUEST['filter'] != '') ) {
                $sql_where = " WHERE (plugin_configstore_backups.filename LIKE '%%" . $_REQUEST['filter'] . "%%' OR
                        plugin_configstore_devices.hostname LIKE '%%" . $_REQUEST['filter'] . "%%' OR 
			plugin_configstore_devices.ipaddress LIKE '%%" . $_REQUEST['filter'] . "%%' OR
			plugin_configstore_backups.directory LIKE '%%" . $_REQUEST['filter'] . "%%' OR
			plugin_configstore_backups.username LIKE '%%" . $_REQUEST['filter'] . "%%')";
        } 
	
	if ( (isset($device)) && ($_REQUEST['filter'] == '') ) {
		$sql_where = " WHERE (plugin_configstore_devices.id = plugin_configstore_backups.device " . ($device != '' ? " AND plugin_configstore_backups.device = $device " : '') . ")";
        } 

	$query_string = " SELECT plugin_configstore_devices.hostname,plugin_configstore_devices.ipaddress,plugin_configstore_backups.id,plugin_configstore_backups.username,plugin_configstore_backups.lastchange, plugin_configstore_backups.btime, plugin_configstore_backups.device, plugin_configstore_backups.directory, plugin_configstore_backups.filename 
		FROM plugin_configstore_devices 
		LEFT JOIN plugin_configstore_backups 
		ON plugin_configstore_devices.id = plugin_configstore_backups.device
                $sql_where
                ORDER BY " . $_REQUEST["sort_column"] . " " . $_REQUEST["sort_direction"];

        if ($apply_limits) {
                $query_string .= " LIMIT " . ($num_rows*($_REQUEST["page"]-1)) . "," . $num_rows;
        }

        return db_fetch_assoc($query_string);
}

function show_backups () {
	global $action, $backup_actions, $colors, $config, $result;

        /* ================= input validation ================= */
        input_validate_input_number(get_request_var_request("page"));
        input_validate_input_number(get_request_var_request("rows"));
        /* ==================================================== */

        /* clean up search filter */
        if (isset($_REQUEST["filter"])) {
                $_REQUEST["filter"] = sanitize_search_string(get_request_var("filter"));
        }

        /* clean up sort_column */
        if (isset($_REQUEST["sort_column"])) {
                $_REQUEST["sort_column"] = sanitize_search_string(get_request_var("sort_column"));
        }

        /* clean up search string */
        if (isset($_REQUEST["sort_direction"])) {
                $_REQUEST["sort_direction"] = sanitize_search_string(get_request_var("sort_direction"));
        }

        /* clean up device string */
        if (isset($_REQUEST["device"])) {
                $_REQUEST["device"] = sanitize_search_string(get_request_var("device"));
        }

        /* if the user pushed the 'clear' button */
        if (isset($_REQUEST["clear_x"])) {
                kill_session_var("sess_configstore_backups_current_page");
                kill_session_var("sess_configstore_backups_filter");
                kill_session_var("sess_configstore_backups_rows");
                kill_session_var("sess_configstore_backups_sort_column");
                kill_session_var("sess_configstore_backups_sort_direction");
		kill_session_var("sess_configstore_backups_device");

                unset($_REQUEST["page"]);
		unset($_REQUEST["device"]);
                unset($_REQUEST["filter"]);
                unset($_REQUEST["rows"]);
                unset($_REQUEST["sort_column"]);
                unset($_REQUEST["sort_direction"]);
        }

        /* remember these search fields in session vars so we don't have to keep passing them around */
        load_current_session_value("page", "sess_configstore_backups_current_page", "1");
        load_current_session_value("filter", "sess_configstore_backups_filter", "");
        load_current_session_value("device", "sess_configstore_backups_device", "");
        load_current_session_value("rows", "sess_configstore_backups_rows", "-1");
        load_current_session_value("sort_column", "sess_configstore_backups_sort_column", "hostname");
        load_current_session_value("sort_direction", "sess_configstore_backups_sort_direction", "ASC");

        if ($_REQUEST["rows"] == -1) {
                $num_rows = 30;
        }elseif ($_REQUEST["rows"] == -2) {
                $num_rows = 999999;
        }else{
                $num_rows = $_REQUEST["rows"];
        }

	if (isset($_REQUEST["device"])) {
		$device = $_REQUEST["device"];
	} else {
		$device = "";
	}

	define("MAX_DISPLAY_PAGES", 21);

        // START Device filter
        html_start_box("<strong>Configstore Backups Filter</strong>", "100%", $colors["header"], "3", "center", "");
        configstore_generic_filter();
        html_end_box();
        // END Device filter

        $sql_where = "";
        $result = configstore_get_backups($sql_where, $num_rows);

	$total_rows = db_fetch_cell("SELECT COUNT(*) FROM plugin_configstore_backups LEFT JOIN plugin_configstore_devices on plugin_configstore_backups.device = plugin_configstore_devices.id $sql_where");
        $url_page_select = get_page_list($_REQUEST["page"], MAX_DISPLAY_PAGES, $num_rows, $total_rows, "configstore_backups.php?");

	html_start_box("", "100%", $colors["header"], "4", "center", "");
	$nav = "<tr bgcolor='#" . $colors["header"] . "'>
			<td colspan='10'>
				<table width='100%' cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td align='left' class='textHeaderDark'>
							<strong>&lt;&lt; "; if ($_REQUEST["page"] > 1) { $nav .= "<a class='linkOverDark' href='configstore_backups.php?page=" . ($_REQUEST["page"]-1) . "'>"; } $nav .= "Previous"; if ($_REQUEST["page"] > 1) { $nav .= "</a>"; } $nav .= "</strong>
						</td>\n
						<td align='center' class='textHeaderDark'>
							Showing Rows " . (($num_rows*($_REQUEST["page"]-1))+1) . " to " . ((($total_rows < $num_rows) || ($total_rows < ($num_rows*$_REQUEST["page"]))) ? $total_rows : ($num_rows*$_REQUEST["page"])) . " of $total_rows [$url_page_select]
						</td>\n
						<td align='right' class='textHeaderDark'>
							<strong>"; if (($_REQUEST["page"] * $num_rows) < $total_rows) { $nav .= "<a class='linkOverDark' href='configstore_backups.php?page=" . ($_REQUEST["page"]+1) . "'>"; } $nav .= "Next"; if (($_REQUEST["page"] * $num_rows) < $total_rows) { $nav .= "</a>"; } $nav .= " &gt;&gt;</strong>
						</td>\n
					</tr>
				</table>
			</td>
		</tr>\n";

	print $nav;

        $display_text = array(
                "hostname" => array("Hostname", "ASC"),
                "view" => array("", ""),
                "directory" => array("Directory", "ASC"),
		"filename" => array("Filename", "ASC"),
                "btime" => array("Backup Time", "DESC"),
                "lastchange" => array("Last Change", "DESC"),
                "username" => array("Changed By", "ASC"));

        html_header_sort_checkbox($display_text, $_REQUEST["sort_column"], $_REQUEST["sort_direction"]);

	$r = db_fetch_assoc("SELECT device, id FROM plugin_configstore_backups ORDER BY btime ASC");
	$latest = array();
	if (count($r)) {
		foreach ($r as $s) {
			$latest[$s['device']] = $s['id'];
		}
	}
	$c=0;
	$i=0;
	foreach ($result as $row) {
		form_alternate_row_color($colors["alternate"],$colors["light"],$i, 'line' . $row["id"]); $i++;
		form_selectable_cell('<a href="configstore_devices.php?&action=edit&id=' . $row['device'] . '">' . $row['hostname'] . '</a>', $row["id"]);
		form_selectable_cell("<a href='configstore_backups.php?action=viewconfig&id=" . $row['id'] . "'>View Config</a> - <a href='configstore_compare.php?device1=" . $row['device'] . '&device2=' . $row['device'] . '&file1=' . $row['id'] . '&file2=' . $latest[$row['device']] . "'>Compare</a>", $row["id"]);
		form_selectable_cell($row['directory'], $row["id"]);
		form_selectable_cell($row['filename'], $row["id"]);
		form_selectable_cell(date('M j Y H:i:s', $row['btime']), $row["id"]);
		if ($row['lastchange'] > 0) {
			form_selectable_cell(date('M j Y H:i:s', $row['lastchange']), $row["id"]);
		} else {
			form_selectable_cell('', $row["id"]);
		}
		form_selectable_cell($row['username'], $row["id"]);
                form_checkbox_cell($row["hostname"], $row["id"]);
                form_end_row();
	}
	print $nav;

        html_end_box(false);
        draw_actions_dropdown($backup_actions);
}


