<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2007 The Cacti Group                                      |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/


chdir('../../');

include("./include/auth.php");

include_once($config['base_path'] . '/plugins/configstore/functions.php');
include_once($config['base_path'] . '/plugins/configstore/include/logger.class.php');

global $log;
$log = new Logging();

$device_type_actions = array(
	1 => "Delete",
	2 => "Duplicate",
);

$action = "";
if (isset($_POST['action'])) {
	$action = $_POST['action'];
} else if (isset($_GET['action'])) {
	$action = $_GET['action'];
}

$backup_scripts_dir = $config['base_path'] . '/plugins/configstore/lib';
$backup_scripts = get_files_in_dir($backup_scripts_dir);

$device_type_edit = array (
        "name" => array(
                "method" => "textbox",
                "friendly_name" => "Name",
                "description" => "Give this device type a meaningful name that will be displayed.",
                "value" => "|arg1:name|",
                "max_length" => "64"
                ),
        "vendor" => array(
                "method" => "textbox",
                "friendly_name" => "Vendor",
                "description" => "Fill in the name for the vendor of this device type.",
                "value" => "|arg1:vendor|",
		"max_length" => "64"
                ),
	"models" => array(
                "method" => "textbox",
                "friendly_name" => "Device Models",
                "description" => "Device models this device type applys to.",
                "value" => "|arg1:models|",
                "max_length" => "128"
                ),
	"backup_script" => array(
		"method" => "drop_array",
        	"friendly_name" => "Backup Script",
                "description" => "Script used to backup devices with this device type.",
		"default" => "None",
		"value" => "|arg1:device_type|",
                "array" => $backup_scripts,
                ),
        "id" => array(
                "method" => "hidden_zero",
                "value" => "|arg1:id|"
                ),
        "action" => array(
                "method" => "hidden_zero",
                "value" => "edit"
                )
        );

switch ($action) {
	case 'actions':
		actions_device_type ();
		break;
	case 'save':
		save_device_type ();
		break;
	case 'edit':
		include_once("./include/top_header.php");
		edit_device_type ();
		include_once("./include/bottom_footer.php");
		break;
	default:
		include_once("./include/top_header.php");
		show_device_type ();
		include_once("./include/bottom_footer.php");
		break;
}

function actions_device_type () {
	global $colors, $device_type_actions, $config;
	if (isset($_POST["selected_items"])) {
		$selected_items = unserialize(stripslashes($_POST["selected_items"]));
		if ($_POST["drp_action"] == "1") { /* delete */

			for ($i=0; $i<count($selected_items); $i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */
				db_execute("DELETE FROM plugin_configstore_device_types WHERE id = " . $selected_items[$i]);
			}
		} elseif ($_POST["drp_action"] == "2") { /* duplicate */
                        for ($i=0;($i<count($selected_items));$i++) {
                                /* ================= input validation ================= */
                                input_validate_input_number($selected_items[$i]);
                                /* ==================================================== */

                                duplicate_device_type($selected_items[$i], $i, $_POST["title_format"]);
                        }
                }

		header("Location: configstore_device_types.php");
		exit;
	}


	/* setup some variables */
	$device_type_list = "";
	$i = 0;

	/* loop through each of the device types selected on the previous page and get more info about them */
	while (list($var,$val) = each($_POST)) {
		if (ereg("^chk_([0-9]+)$", $var, $matches)) {
			/* ================= input validation ================= */
			input_validate_input_number($matches[1]);
			/* ==================================================== */

			$device_type_list .= "<li>" . db_fetch_cell("SELECT name FROM plugin_configstore_device_types WHERE id=" . $matches[1]) . "<br>";
			$device_type_array[$i] = $matches[1];
		}
		$i++;
	}

	include_once("./include/top_header.php");

	html_start_box("<strong>" . $device_type_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "3", "center", "");

	print "<form action='configstore_device_types.php' method='post'>\n";

	if ($_POST["drp_action"] == "1") { /* Delete */
		print "	<tr>
				<td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
					<p>To delete the following device types, press the \"yes\" button below.</p>
					<p><ul>$device_type_list</ul></p>
				</td>
				</tr>";
	} elseif ($_POST["drp_action"] == "2") { /* duplicate */
                print " <tr>
                                <td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
                                        <p>When you click save, the following device type will be duplicated. You may optionally change the description for the new device type.  Otherwise, do not change value below and the original name will be replicated with a new suffix.</p>
                                        <p><ul>$device_type_list</ul></p>
                                        <p><strong>Device Type Prefix:</strong><br>"; form_text_box("title_format", "<name> (1)", "", "255", "30", "text"); print "</p>
                                </td>
                        </tr>\n
             ";
        }

	if (!isset($device_type_list)) {
                print "<tr><td bgcolor='#" . $colors["form_alternate1"]. "'><span class='textError'>You must select at least one device type.</span></td></tr>\n";
                $save_html = "";
        }else{
		$save_html = "<input type='image' src='" . $config['url_path'] . "images/button_yes.gif' alt='Save' align='absmiddle'>";
        }

        print " <tr>
                        <td colspan='2' align='right' bgcolor='#eaeaea'>
                                <input type='hidden' name='action' value='actions'>
                                <input type='hidden' name='selected_items' value='" . (isset($device_type_array) ? serialize($device_type_array) : '') . "'>
                                <input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
                                <a href='configstore_device_types.php'><img src='" . $config['url_path'] . "images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
                                $save_html
                        </td>
                </tr>
        ";

        html_end_box();

        include_once("./include/bottom_footer.php");
}

function save_device_type() {
	global $log;
	/* ================= input validation ================= */
        input_validate_input_number(get_request_var_post("id"));
        /* ==================================================== */

        if (isset($_POST['id'])) {
		$id = $_POST["id"];
        } else {
                $id = '';
        }

	$backup_script = $_POST["backup_script"];
	$models = $_POST["models"];
	$vendor = $_POST["vendor"];
	$name = $_POST["name"];

	if ( (empty($backup_script)) || (empty($vendor)) || (empty($name)) ) {
		raise_message(2);
	}
	$save["id"] = $id;
	$save["name"] = $name;
	$save["vendor"] = $vendor;
	$save["models"] = $models;
	$save["backup_script"] = $backup_script;

	$id = sql_save($save, "plugin_configstore_device_types", "id");

	if (is_error_message()) {
		header ("Location: configstore_device_types.php?action=edit&id=" . (empty($id) ? $_POST["id"] : $id));
		exit;
	}
	header("Location: configstore_device_types.php");
	exit;
}

function edit_device_type () {
	global $device_type_edit, $colors;

        /* ================= input validation ================= */
        input_validate_input_number(get_request_var_post("id"));
        /* ==================================================== */

        # fetch the current device type record
	$device_type = array();
	if (!empty($_GET["id"])) {
        	$device_type = db_fetch_row("SELECT * FROM plugin_configstore_device_types WHERE id=" . $_GET["id"], FALSE);
		$header_label = "[edit: " . $device_type["name"] . "]";
	} else {
		$header_label = "[new]";
	}

	html_start_box("<strong>Device Type:</strong> $header_label", "98%", $colors["header"], "3", "center", "");
	draw_edit_form(array(
		"config" => array("form_name" => "chk"),
		"fields" => inject_form_variables($device_type_edit, $device_type)
		)
	);

	html_end_box();
	form_save_button("configstore_device_types.php");
}

function configstore_get_device_types(&$sql_where, $num_rows, $apply_limits = TRUE) {
        global $log;
        if ($_REQUEST["filter"] != "") {
                $sql_where = " WHERE (plugin_configstore_device_types.name LIKE '%%" . $_REQUEST["filter"] . "%%')";
        }

        $query_string = "SELECT * FROM plugin_configstore_device_types $sql_where ORDER BY " . $_REQUEST["sort_column"] . " " . $_REQUEST["sort_direction"];

        if ($apply_limits) {
                $query_string .= " LIMIT " . ($num_rows*($_REQUEST["page"]-1)) . "," . $num_rows;
        }

        return db_fetch_assoc($query_string);
}

function show_device_type () {
	global $action, $colors, $config, $device_type_actions;

        /* ================= input validation ================= */
        input_validate_input_number(get_request_var_request("page"));
        input_validate_input_number(get_request_var_request("rows"));
        /* ==================================================== */

        /* clean up search filter */
        if (isset($_REQUEST["filter"])) {
                $_REQUEST["filter"] = sanitize_search_string(get_request_var("filter"));
        }

        /* clean up sort_column */
        if (isset($_REQUEST["sort_column"])) {
                $_REQUEST["sort_column"] = sanitize_search_string(get_request_var("sort_column"));
        }

        /* clean up search string */
        if (isset($_REQUEST["sort_direction"])) {
                $_REQUEST["sort_direction"] = sanitize_search_string(get_request_var("sort_direction"));
        }

        /* if the user pushed the 'clear' button */
        if (isset($_REQUEST["clear_x"])) {
                kill_session_var("sess_configstore_device_type_current_page");
                kill_session_var("sess_configstore_device_type_filter");
                kill_session_var("sess_configstore_device_type_rows");
                kill_session_var("sess_configstore_device_type_sort_column");
                kill_session_var("sess_configstore_device_type_sort_direction");

                unset($_REQUEST["page"]);
                unset($_REQUEST["filter"]);
                unset($_REQUEST["rows"]);
                unset($_REQUEST["sort_column"]);
                unset($_REQUEST["sort_direction"]);
        }

        /* remember these search fields in session vars so we don't have to keep passing them around */
	load_current_session_value("page", "sess_configstore_device_type_current_page", "1");
	load_current_session_value("filter", "sess_configstore_device_type_filter", "");
	load_current_session_value("rows", "sess_configstore_device_type_rows", "-1");
	load_current_session_value("sort_column", "sess_configstore_device_type_sort_column", "name");
	load_current_session_value("sort_direction", "sess_configstore_device_type_sort_direction", "ASC");


        if ($_REQUEST["rows"] == -1) {
                $num_rows = 30;
        }elseif ($_REQUEST["rows"] == -2) {
                $num_rows = 999999;
        }else{
                $num_rows = $_REQUEST["rows"];
        }

        define("MAX_DISPLAY_PAGES", 21);
        $total_rows = db_fetch_cell("SELECT COUNT(*) FROM plugin_configstore_device_types");
        $url_page_select = get_page_list($_REQUEST["page"], MAX_DISPLAY_PAGES, $num_rows, $total_rows, "configstore_device_types.php?");

        // START Device filter
        html_start_box("<strong>Configstore Device Type Filters</strong>", "98%", $colors["header"], "3", "center", "configstore_device_types.php?action=edit");
        configstore_generic_filter();
        html_end_box();
        // END Device filter

        $sql_where = "";
        $result = configstore_get_device_types($sql_where, $num_rows);
	html_start_box("", "98%", $colors["header"], "4", "center", "");
	$nav = "<tr bgcolor='#" . $colors["header"] . "'>
			<td colspan='10'>
				<table width='100%' cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td align='left' class='textHeaderDark'>
							<strong>&lt;&lt; "; if ($_REQUEST["page"] > 1) { $nav .= "<a class='linkOverDark' href='configstore_device_types.php?page=" . ($_REQUEST["page"]-1) . "'>"; } $nav .= "Previous"; if ($_REQUEST["page"] > 1) { $nav .= "</a>"; } $nav .= "</strong>
						</td>\n
						<td align='center' class='textHeaderDark'>
							Showing Rows " . (($num_rows*($_REQUEST["page"]-1))+1) . " to " . ((($total_rows < $num_rows) || ($total_rows < ($num_rows*$_REQUEST["page"]))) ? $total_rows : ($num_rows*$_REQUEST["page"])) . " of $total_rows [$url_page_select]
						</td>\n
						<td align='right' class='textHeaderDark'>
							<strong>"; if (($_REQUEST["page"] * $num_rows) < $total_rows) { $nav .= "<a class='linkOverDark' href='configstore_device_types.php?page=" . ($_REQUEST["page"]+1) . "'>"; } $nav .= "Next"; if (($_REQUEST["page"] * $num_rows) < $total_rows) { $nav .= "</a>"; } $nav .= " &gt;&gt;</strong>
						</td>\n
					</tr>
				</table>
			</td>
		</tr>\n";

	print $nav;

        $display_text = array(
                "name" => array("Name", "ASC"),
		"vendor" => array("Vendor", "ASC"),
		"backup_script" => array("Backup Script", "ASC"),
                "count" => array("Devices", "DESC"));

        html_header_sort_checkbox($display_text, $_REQUEST["sort_column"], $_REQUEST["sort_direction"]);

	$count=0;
	$i=0;
	foreach ($result as $row) {
                $count = db_fetch_cell("SELECT count(devicetype) FROM plugin_configstore_devices WHERE devicetype = " . $row['id']);

		form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
		print '<td><a href="configstore_device_types.php?&action=edit&id=' . $row['id'] . '">' . $row['name'] . '</a></td>';
		print '<td>' . $row["vendor"] . '</td>';
		print '<td>' . $row["backup_script"] . '</td>';
		print '<td><a href="configstore_devices.php?device_type=' . $row['id'] . '">' . $count . '</a></td>';

		print '<td style="' . get_checkbox_style() . '" width="1%" align="right">';
		print '<input type="checkbox" style="margin: 0px;" name="chk_' . $row["id"] . '" title="' . $row["name"] . '"></td>';
		print "</tr>";
	}
	print $nav;

	html_end_box(false);
	draw_actions_dropdown($device_type_actions);

	print "&nbsp;&nbsp;&nbsp;<a href='configstore_device_types.php?action=edit'><img border=0 src='" . $config['url_path'] . "images/button_add.gif'></a>";

}

function duplicate_device_type ($id, $dup_id, $name) {
        if (!empty($id)) {
                $device_type = db_fetch_row("SELECT * FROM plugin_configstore_device_types WHERE id=$id");

                /* create new device type */
                $save["id"] = 0;

                if (substr_count($name, "<name>")) {
                        $save["name"] = $device_type["name"] . "(1)";
                }else{
                        $save["name"] = $name . "(" . $dup_id . ")";
                }

                $save["vendor"] = $device_type["vendor"];
		$save["models"] = $device_type["models"];
		$save["backup_script"] = $device_type["backup_script"];

                $id = sql_save($save, "plugin_configstore_device_types", array("id"));
        }
}
