<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2007 The Cacti Group                                      |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/


chdir('../../');

include("./include/auth.php");

include_once($config['base_path'] . '/plugins/configstore/functions.php');
include_once($config['base_path'] . '/plugins/configstore/include/logger.class.php');

global $log;
$log = new Logging();

$ds_actions = array(1 => 'Backup Devices', 2 => 'Delete Devices', 3 => 'Delete Backups', 4 => 'Disable Backups', 5 => 'Enable Backups', 6 => 'Change Account', 7 => 'Change Site');

$action = "";
if (isset($_POST['action'])) {
	$action = $_POST['action'];
} else if (isset($_GET['action'])) {
	$action = $_GET['action'];
}

$sites = array('None');
$sites_array = db_fetch_assoc("SELECT id, site_id, name FROM plugin_configstore_sites ORDER BY site_id", false);
if (!empty($sites_array)) {
	foreach ($sites_array as $s) {
		$sites[$s['id']] = $s['site_id'] . " - " . $s['name'];
	}
}

$acc = array('None');
$accounts = db_fetch_assoc("SELECT id, name FROM plugin_configstore_accounts ORDER BY name", false);
if (!empty($accounts)) {
	foreach ($accounts as $a) {
		$acc[$a['id']] = $a['name'];
	}
}

$dts = array('None');
$device_types = db_fetch_assoc("SELECT id, name FROM plugin_configstore_device_types ORDER BY name", false);
if (!empty($device_types)) {
	foreach ($device_types as $d) {
		$dts[$d['id']] = $d['name'];
	}
}

$change_account_edit = array(
        "account" => array(
                "method" => "drop_array",
                "value" => "|arg1:account|",
                "default" => 0,
                "array" => $acc,
                ),
	);

$change_site_edit = array(
        "site" => array(
                "method" => "drop_array",
                "value" => "|arg1:site|",
                "default" => 0,
                "array" => $sites,
                ),
        );

$account_edit = array(
	'enabled' => array(
		'method' => 'checkbox',
		'friendly_name' => 'Enable Device',
		'description' => 'Uncheck this box to disabled this device from being backed up.',
		'value' => '|arg1:enabled|',
		'default' => '',
		"form_id" => false
		),
	"hostname" => array(
		"method" => "textbox",
		"friendly_name" => "Description",
		"description" => "Name of this device (will be used for config saving if no hostname is present in config).",
		"value" => "|arg1:hostname|",
		"max_length" => "128",
		),
	"ipaddress" => array(
		"method" => "textbox",
		"friendly_name" => "IP Address",
		"description" => "This is the IP Address used to communicate with the device.",
		"value" => "|arg1:ipaddress|",
		"max_length" => "128",
		),
	"directory" => array(
		"method" => "textbox",
		"friendly_name" => "Directory",
		"description" => "This is the relative directory structure used to store the configs.",
		"value" => "|arg1:directory|",
		"max_length" => "255",
		),
	"site" => array(
		"method" => "drop_array",
		"friendly_name" => "Site",
		"description" => "Choose the site to associate this device with.",
		"value" => "|arg1:site|",
		"default" => 0,
		"array" => $sites,
		),
	"schedule" => array(
		"method" => "drop_array",
		"friendly_name" => "Schedule",
		"description" => "How often to Backup this device.",
		"value" => "|arg1:schedule|",
		"default" => 1,
		"array" => array(0 => 'Daily', 7 => 'Weekly', 30 => 'Monthly'),
		),
	"devicetype" => array(
		"method" => "drop_array",
		"friendly_name" => "Device Type",
		"description" => "Choose the type of device.",
		"value" => "|arg1:devicetype|",
		"default" => 0,
		"array" => $dts,
		),
	"account" => array(
		"method" => "drop_array",
		"friendly_name" => "Authenication Account",
		"description" => "Choose an account to use to Login to the device.",
		"value" => "|arg1:account|",
		"default" => 0,
		"array" => $acc,
		),
	"id" => array(
		"method" => "hidden_zero",
		"value" => "|arg1:id|"
		),
	"action" => array(
		"method" => "hidden_zero",
		"value" => "edit"
		)
	);

switch ($action) {
	case 'viewdebug':
		plugin_configstore_view_device_debug();
		break;
	case 'viewconfig':
		view_device_config();
		break;
	case 'actions':
		actions_devices();
		break;
	case 'save':
		save_devices ();
		break;
	case 'edit':
		include_once("./include/top_header.php");
		display_tabs ();
		edit_devices();
		include_once("./include/bottom_footer.php");
		break;
	default:
		include_once("./include/top_header.php");
		display_tabs ();
		show_devices ();
		include_once("./include/bottom_footer.php");
		break;
}

function plugin_configstore_view_device_debug () {
	global $colors;
	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("id"));
	/* ==================================================== */
	$device = array();
	if (!empty($_GET["id"])) {
		$device = db_fetch_row("SELECT * FROM plugin_configstore_devices WHERE id=" . $_GET["id"], FALSE);
	}

	if (isset($device['id'])) {
		include_once("./include/top_header.php");
		display_tabs ();
		html_start_box("", "100%", $colors["header"], "4", "center", "");
		form_alternate_row_color($colors["alternate"],$colors["light"],0);
		print '<td><h2>Debug for ' . $device['hostname'] . ' (' . $device['ipaddress'] . ')<br><br>';
		print '</h1><textarea rows=36 cols=120>';
		print base64_decode($device['debug']);
		print '</textarea></td></tr>';
		html_end_box(false);
	} else {
		header("Location: configstore_devices.php");
		exit;
	}
}

function display_tabs () {
	/* draw the categories tabs on the top of the page */
	print "<table class='tabs' width='100%' cellspacing='0' cellpadding='3' align='center'><tr>\n";
        print "<td bgcolor='#DFDFDF' nowrap='nowrap' width='" . (strlen('Sites') * 9) . "' align='center' class='tab'>
                        <span class='textHeader'><a href='configstore_sites.php'>Sites</a></span>
                        </td>\n
                        <td width='1'></td>\n";
	print "<td bgcolor='silver' nowrap='nowrap' width='" . (strlen('Devices') * 9) . "' align='center' class='tab'>
			<span class='textHeader'><a href='configstore_devices.php'>Devices</a></span>
			</td>\n
			<td width='1'></td>\n";
	print "<td bgcolor='#DFDFDF' nowrap='nowrap' width='" . (strlen('Backups') * 9) . "' align='center' class='tab'>
			<span class='textHeader'><a href='configstore_backups.php?device='>Backups</a></span>
			</td>\n
			<td width='1'></td>\n";
	print "<td bgcolor='#DFDFDF' nowrap='nowrap' width='" . (strlen('Accounts') * 9) . "' align='center' class='tab'>
			<span class='textHeader'><a href='configstore_accounts.php'>Accounts</a></span>
			</td>\n
			<td width='1'></td>\n";
	print "<td bgcolor='#DFDFDF' nowrap='nowrap' width='" . (strlen('Compare') * 9) . "' align='center' class='tab'>
			<span class='textHeader'><a href='configstore_compare.php'>Compare</a></span>
			</td>\n
			<td width='1'></td>\n";
	print "<td></td>\n</tr></table>\n";
}


function view_device_config() {
	global $colors;
	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("id"));
	/* ==================================================== */
	$device = array();
	if (!empty($_GET["id"])) {
		$device = db_fetch_row("SELECT plugin_configstore_backups.*, plugin_configstore_devices.hostname, plugin_configstore_devices.ipaddress
					 FROM plugin_configstore_devices,plugin_configstore_backups
					 WHERE plugin_configstore_backups.device = plugin_configstore_devices.id AND plugin_configstore_backups.device=" . $_GET["id"]
					. " ORDER BY btime DESC", FALSE);
	}

	if (isset($device['id'])) {
		include_once("./include/top_header.php");
		display_tabs ();
		html_start_box("", "100%", $colors["header"], "4", "center", "");
		form_alternate_row_color($colors["alternate"],$colors["light"],0);
		print '<td><h2>Config for ' . $device['hostname'] . ' (' . $device['ipaddress'] . ')<br><br>';
		print 'Backup from ' . date('M j Y H:i:s', $device['btime']) . '<br>';
		print 'File: ' . $device['directory'] . '/' . $device['filename'];
		print '</h1><textarea rows=36 cols=120>';
		print $device['config'];
		print '</textarea></td></tr>';
		html_end_box(false);
	} else {
		header("Location: configstore_devices.php");
		exit;
	}
}

function actions_devices () {
	global $colors, $ds_actions, $config, $log, $change_account_edit, $change_site_edit;

        if (isset($_POST["selected_items"])) {
                $selected_items = unserialize(stripslashes($_POST["selected_items"]));
		if ($_POST["drp_action"] == "2") { // Delete and Archive Backups, then Delete Device.
			$backups = array();
			for ($i=0; $i<count($selected_items); $i++) {
                        	/* ================= input validation ================= */
                        	input_validate_input_number($selected_items[$i]);
                      	 	/* ==================================================== */

                                $backup_ids = array();
                                $backups = db_fetch_assoc("SELECT id FROM plugin_configstore_backups WHERE device = " . $selected_items[$i]);
                                foreach ($backups as $b) { array_push($backup_ids, $b['id']);  }
                                $archive_results = plugin_configstore_archive_backups ($backup_ids);

                   		if ($archive_results) {
                                	db_execute("DELETE FROM plugin_configstore_devices WHERE id = " . $selected_items[$i]);
                        	} else {
                        	}
			}
		}

		if ($_POST["drp_action"] == "3") { // Delete and Archive Backups for Device.
			for ($i=0; $i<count($selected_items); $i++) {
                                /* ================= input validation ================= */
                                input_validate_input_number($selected_items[$i]);
                                /* ==================================================== */

				$backup_ids = array();
				$backups = db_fetch_assoc("SELECT id FROM plugin_configstore_backups WHERE device = " . $selected_items[$i]);
				foreach ($backups as $b) { array_push($backup_ids, $b['id']);  }
	                        $archive_results = plugin_configstore_archive_backups ($backup_ids);

        	                if ($archive_results) {
                       		} else {
                        	}

                	}	
		}

		if ($_POST["drp_action"] == "4") { // Disable Backups for Devices.
               	        for ($i=0; $i<count($selected_items); $i++) {
                                /* ================= input validation ================= */
                       	        input_validate_input_number($selected_items[$i]);
                       		/* ==================================================== */
				db_execute("UPDATE plugin_configstore_devices SET enabled = '' WHERE id = " . $selected_items[$i]);
               	        }
               }

                if ($_POST["drp_action"] == "5") { // Enable Backups for Devices.
                        for ($i=0; $i<count($selected_items); $i++) {
                                /* ================= input validation ================= */
                                input_validate_input_number($selected_items[$i]);
                                /* ==================================================== */
				db_execute("UPDATE plugin_configstore_devices SET enabled = 'on' WHERE id = " . $selected_items[$i]);
                        }
                }

		if ($_POST["drp_action"] == "6") { // Change Account for Devices.
			for ($i=0; $i<count($selected_items); $i++) {
				                                /* ================= input validation ================= */
                                input_validate_input_number($selected_items[$i]);
                                /* ==================================================== */

				if (isset($_POST["account"])) {
					db_execute("UPDATE plugin_configstore_devices SET account = '" . $_POST["account"] . "' WHERE id = " . $selected_items[$i]);
				}
                        }
                }

                if ($_POST["drp_action"] == "7") { // Change Site for Devices.
                        for ($i=0; $i<count($selected_items); $i++) {
                                /* ================= input validation ================= */
                                input_validate_input_number($selected_items[$i]);
                                /* ==================================================== */
                                if (isset($_POST["site"])) {
                                        db_execute("UPDATE plugin_configstore_devices SET site = '" . $_POST["site"] . "' WHERE id = " . $selected_items[$i]);
                                }
                        }
                }

		header("Location: configstore_devices.php");
		exit;
	}


	/* setup some variables */
	$account_list = "";
	$i = 0;

	/* loop through each of the devices selected on the previous page and get more info about them */
	while (list($var,$val) = each($_POST)) {
		if (ereg("^chk_([0-9]+)$", $var, $matches)) {
			/* ================= input validation ================= */
			input_validate_input_number($matches[1]);
			/* ==================================================== */

			$account_list .= "<li>" . db_fetch_cell("SELECT hostname FROM plugin_configstore_devices WHERE id=" . $matches[1]) . "<br>";
			$account_array[$i] = $matches[1];
		}
		$i++;
	}

	if ($_POST["drp_action"] == "1") { /* Backup */
		ini_set("max_execution_time", 0);
		ini_set("memory_limit", "256M");
		foreach ($account_array as $id) {
			$device = db_fetch_assoc("SELECT * FROM plugin_configstore_devices WHERE id = $id");
			$result = plugin_configstore_download_config($device[0]);

			if ($result) {
                                db_execute("UPDATE plugin_configstore_devices SET backupresult='0', failedcount='0' WHERE id = " . $device[0]['id']);
                        } else {
                                $failedcount = db_fetch_cell("SELECT failedcount FROM plugin_configstore_devices WHERE id = " . $device[0]['id']);
                                $failedcount++;

                                if ($failedcount > 2) {
                                        db_execute("UPDATE plugin_configstore_devices SET backupresult='1', failedcount='0', enabled='' WHERE id = " . $device[0]['id']);
                                } else {
                                        db_execute("UPDATE plugin_configstore_devices SET backupresult='1', failedcount='$failedcount' WHERE id = " . $device[0]['id']);
                                }
			}
		}
		header("Location: configstore_devices.php");
		exit;
	}

	include_once("./include/top_header.php");

	html_start_box("<strong>" . $ds_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "3", "center", "");

	print "<form action='configstore_devices.php' method='post'>\n";
	if ($_POST["drp_action"] == "2") { /* Delete */
		print "	<tr>
				<td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
					<p>To delete the following devices, press the \"yes\" button below.</p>
					<p><ul>$account_list</ul></p>
				</td>
				</tr>";
	}

        if ($_POST["drp_action"] == "3") { /* Delete Backups */
                print " <tr>
                                <td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
                                        <p>To delete and archive the following devices backups press the \"yes\" button below.</p>
                                        <p><ul>$account_list</ul></p>
                                </td>
                                </tr>";
        }

        if ($_POST["drp_action"] == "4") { /* Disable Device Backups */
                print " <tr>
                                <td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
                                        <p>To disable backups for the following devices press the \"yes\" button below.</p>
                                        <p><ul>$account_list</ul></p>
                                </td>
                                </tr>";
        }

        if ($_POST["drp_action"] == "5") { /* Enable Device Backups */
                print " <tr>
                                <td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
                                        <p>To enable backups for the following devices press the \"yes\" button below.</p>
					<p><ul>$account_list</ul></p>
                                </td>
                                </tr>";
        }

	if ($_POST["drp_action"] == "6") { /* Change Account for Devices */
		print " <tr>
				<td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
					<p>To change the account used to authenicate to the following devices, select a new account and press the \"yes\" button below.</p><center><br>";
		print " 	<p>Authentication Account:</p>";
				html_start_box();
				draw_edit_form(array(
                			"config" => array("form_name" => "chk"),
                			"fields" => $change_account_edit,
                			)
				);
				html_end_box();
		print "
					</center>
					<p>&nbsp;&nbsp;&nbsp;&nbsp;Devices to be modified:</p>
					<p><ul>$account_list</ul></p>
				</td>
				</tr>";
					
	}

        if ($_POST["drp_action"] == "7") { /* Change Site for Devices */
                print " <tr>
                                <td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
                                        <p>To change the site for the following devices, select a new site and press the \"yes\" button below.</p><center><br>";
                print "         <p>Site:</p>";
                                html_start_box();
                                draw_edit_form(array(
                                        "config" => array("form_name" => "chk"),
                                        "fields" => $change_site_edit,
                                        )
                                );
                                html_end_box();
                print "
                                        </center>
                                        <p>&nbsp;&nbsp;&nbsp;&nbsp;<b>Devices to be modified:</b></p>
                                        <p><ul>$account_list</ul></p>
                                </td>
                                </tr>";
                                        
        }


	if (!isset($account_array)) {
		print "<tr><td bgcolor='#" . $colors["form_alternate1"]. "'><span class='textError'>You must select at least one device.</span></td></tr>\n";
		$save_html = "";
	}else{
		$save_html = "<input type='image' src='" . $config['url_path'] . "images/button_yes.gif' alt='Save' align='absmiddle'>";
	}

	print "	<tr>
			<td colspan='2' align='right' bgcolor='#eaeaea'>
				<input type='hidden' name='action' value='actions'>
				<input type='hidden' name='selected_items' value='" . (isset($account_array) ? serialize($account_array) : '') . "'>
				<input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
				<a href='configstore_devices.php'><img src='" . $config['url_path'] . "images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
				$save_html
			</td>
		</tr>
		";

	html_end_box();

	include_once("./include/bottom_footer.php");


}

function save_devices () {
	/* ================= input validation ================= */
	input_validate_input_number(get_request_var_post("id"));
	input_validate_input_number(get_request_var_post("devicetype"));
	input_validate_input_number(get_request_var_post("schedule"));
	/* ==================================================== */

	if (isset($_POST['id'])) {
		$save['id'] = $_POST['id'];
	} else {
		$save['id'] = '';
	}


	if (isset($_POST['enabled'])) {
		$save['enabled'] = 'on';
	} else {
		$save['enabled'] = '';
	}

	$save['hostname'] = sql_sanitize($_POST['hostname']);
	$save['ipaddress'] = sql_sanitize($_POST['ipaddress']);
	$save['directory'] = sql_sanitize($_POST['directory']);
	$save['account'] = sql_sanitize($_POST['account']);
	$save['devicetype'] = sql_sanitize($_POST['devicetype']);
	$save['site'] = sql_sanitize($_POST['site']);
	$save['schedule'] = sql_sanitize($_POST['schedule']);

	$id = sql_save($save, 'plugin_configstore_devices', 'id');

	if (is_error_message()) {
		header("Location: configstore_devices.php?action=edit&id=" . (empty($id) ? $_POST["id"] : $id));
		exit;
	}

	header("Location: configstore_devices.php");
	exit;

}

function edit_devices () {
	global $account_edit, $colors;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("id"));
	/* ==================================================== */

	$account = array();
	if (!empty($_GET["id"])) {
		$account = db_fetch_row("SELECT * FROM plugin_configstore_devices WHERE id=" . $_GET["id"], FALSE);
		$header_label = "[edit: " . $account["hostname"] . "]";
	}else{
		$header_label = "[new]";
	}

	html_start_box("<strong>Query:</strong> $header_label", "100%", $colors["header"], "3", "center", "");
	draw_edit_form(array(
		"config" => array("form_name" => "chk"),
		"fields" => inject_form_variables($account_edit, $account)
		)
	);

	html_end_box();
	form_save_button("configstore_devices.php");
}

function configstore_get_devices(&$sql_where, $num_rows, $apply_limits = TRUE) {
	global $log;
	if ( (isset($_REQUEST['filter'])) && ($_REQUEST['filter'] != '') ) {
                $sql_where = " WHERE (plugin_configstore_devices.hostname LIKE '%%" . $_REQUEST["filter"] . "%%' OR
                        plugin_configstore_devices.ipaddress LIKE '%%" . $_REQUEST["filter"] . "%%' OR
			plugin_configstore_devices.directory LIKE '%%" . $_REQUEST["filter"] . "%%' OR
			plugin_configstore_devices.username LIKE '%%" . $_REQUEST["filter"] . "%%')";
        }

        if ($_REQUEST["device_status"] == "-1") {
                /* Show all items */
        } elseif ($_REQUEST["device_status"] == "0") {
		$sql_where .= (strlen($sql_where) ? " AND ": " WHERE ") . "(plugin_configstore_devices.enabled='on')";
	} elseif ($_REQUEST["device_status"] == "1") {
                $sql_where .= (strlen($sql_where) ? " AND ": " WHERE ") . "(plugin_configstore_devices.enabled='')";
        }

        if ($_REQUEST["backupresult"] == "-1") {
                /* Show all items */
        } elseif ($_REQUEST["backupresult"] == "0") {
                $sql_where .= (strlen($sql_where) ? " AND ": " WHERE ") . "(plugin_configstore_devices.backupresult='0')";
        } elseif ($_REQUEST["backupresult"] == "1") {
                $sql_where .= (strlen($sql_where) ? " AND ": " WHERE ") . "(plugin_configstore_devices.backupresult='1')";
        }

        if ($_REQUEST["device_type"] == "-1") {
                /* Show all items */
        } else {
                $sql_where .= (strlen($sql_where) ? " AND ": " WHERE ") . "(plugin_configstore_devices.devicetype=" . $_REQUEST["device_type"] . ")";
        }

	if ($_REQUEST["site"] == "-1") {
		/* Show all items */
	} else {
		$sql_where .= (strlen($sql_where) ? " AND ": " WHERE ") . "(plugin_configstore_devices.site=" . $_REQUEST["site"] . ")";
	}

	if ( (!isset($_REQUEST["account"])) || ($_REQUEST["account"] == "") ) {
		/* Show all items */
	} else {
		$sql_where .= (strlen($sql_where) ? " AND ": "WHERE ") . "(plugin_configstore_devices.account=" . $_REQUEST["account"] . ")";
	}

        $query_string = "SELECT *
                FROM plugin_configstore_devices
                $sql_where
                ORDER BY " . $_REQUEST["sort_column"] . " " . $_REQUEST["sort_direction"];

        if ($apply_limits) {
                $query_string .= " LIMIT " . ($num_rows*($_REQUEST["page"]-1)) . "," . $num_rows;
        }

        return db_fetch_assoc($query_string);
}

function show_devices () {
	global $action, $host, $username, $password, $command;
	global $colors, $config, $ds_actions, $acc, $result, $account;

	/* ================= input validation ================= */
      	input_validate_input_number(get_request_var_request("page"));
	input_validate_input_number(get_request_var_request("device_type"));
	input_validate_input_number(get_request_var_request("site"));
	input_validate_input_number(get_request_var_request("device_status"));
        input_validate_input_number(get_request_var_request("backupresult"));
      	input_validate_input_number(get_request_var_request("rows"));
	input_validate_input_number(get_request_var_request("account"));
      	/* ==================================================== */

	/* clean up the account string */
	if (isset($_REQUEST["account"])) {
		$_REQUEST["account"] = sanitize_search_string(get_request_var("account"));
		$account = $_REQUEST["account"];
	}

        /* clean up the status string */
        if (isset($_REQUEST["device_status"])) {
                $_REQUEST["device_status"] = sanitize_search_string(get_request_var("device_status"));
        }

        /* clean up the backup result string */
        if (isset($_REQUEST["backupresult"])) {
                $_REQUEST["backupresult"] = sanitize_search_string(get_request_var("backupresult"));
        }
	
	/* clean up search filter */
        if (isset($_REQUEST["filter"])) {
                $_REQUEST["filter"] = sanitize_search_string(get_request_var("filter"));
        }

        /* clean up sort_column */
        if (isset($_REQUEST["sort_column"])) {
                $_REQUEST["sort_column"] = sanitize_search_string(get_request_var("sort_column"));
        }

        /* clean up search string */
        if (isset($_REQUEST["sort_direction"])) {
                $_REQUEST["sort_direction"] = sanitize_search_string(get_request_var("sort_direction"));
        }

        /* clean up device_type string */
        if (isset($_REQUEST["device_type"])) {
                $_REQUEST["device_type"] = sanitize_search_string(get_request_var("device_type"));
        }

        /* clean up site string */
        if (isset($_REQUEST["site"])) {
                $_REQUEST["site"] = sanitize_search_string(get_request_var("site"));
        }

        /* if the user pushed the 'clear' button */
        if (isset($_REQUEST["clear_x"])) {
                kill_session_var("sess_configstore_devices_current_page");
                kill_session_var("sess_configstore_devices_filter");
                kill_session_var("sess_configstore_devices_rows");
                kill_session_var("sess_configstore_devices_status");
                kill_session_var("sess_configstore_devices_site");
                kill_session_var("sess_configstore_devices_backupresult");
                kill_session_var("sess_configstore_devices_device_type");
                kill_session_var("sess_configstore_devices_sort_column");
                kill_session_var("sess_configstore_devices_sort_direction");

                unset($_REQUEST["page"]);
		unset($_REQUEST["account"]);
                unset($_REQUEST["device_status"]);
		unset($_REQUEST["backupresult"]);
                unset($_REQUEST["filter"]);
                unset($_REQUEST["device_type"]);
                unset($_REQUEST["site"]);
                unset($_REQUEST["rows"]);
                unset($_REQUEST["sort_column"]);
                unset($_REQUEST["sort_direction"]);
        }

        /* remember these search fields in session vars so we don't have to keep passing them around */
        load_current_session_value("page", "sess_configstore_devices_current_page", "1");
        load_current_session_value("device_status", "sess_configstore_devices_status", "-1");
        load_current_session_value("backupresult", "sess_configstore_devices_backupresult", "-1");
        load_current_session_value("filter", "sess_configstore_devices_filter", "");
        load_current_session_value("device_type", "sess_configstore_devices_device_type", "-1");
        load_current_session_value("site", "sess_configstore_devices_site", "-1");
        load_current_session_value("rows", "sess_configstore_devices_rows", "-1");
        load_current_session_value("sort_column", "sess_configstore_devices_sort_column", "hostname");
        load_current_session_value("sort_direction", "sess_configstore_devices_sort_direction", "ASC");

        if ($_REQUEST["rows"] == -1) {
                $num_rows = 30;
        }elseif ($_REQUEST["rows"] == -2) {
                $num_rows = 999999;
        }else{
                $num_rows = $_REQUEST["rows"];
        }
	define("MAX_DISPLAY_PAGES", 21);

	// START Device filter
        html_start_box("<strong>Configstore Device Filters</strong>", "100%", $colors["header"], "3", "center", "configstore_devices.php?action=edit");
        configstore_devices_filter();
        html_end_box();
	// END Device filter

        $sql_where = "";
        $result = configstore_get_devices($sql_where, $num_rows);

	$total_rows = db_fetch_cell("SELECT COUNT(id) FROM plugin_configstore_devices $sql_where"); 

        $url_page_select = get_page_list($_REQUEST["page"], MAX_DISPLAY_PAGES, $num_rows, $total_rows, "configstore_devices.php?" . ($account != '' ? "account=$account" : ''));

	html_start_box("", "100%", $colors["header"], "4", "center", "");
	$nav = "<tr bgcolor='#" . $colors["header"] . "'>
			<td colspan='11'>
				<table width='100%' cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td align='left' class='textHeaderDark'>
							<strong>&lt;&lt; "; if ($_REQUEST["page"] > 1) { $nav .= "<a class='linkOverDark' href='configstore_devices.php?page=" . ($_REQUEST["page"]-1) . ($account != '' ? "&account=$account" : '') . "'>"; } $nav .= "Previous"; if ($_REQUEST["page"] > 1) { $nav .= "</a>"; } $nav .= "</strong>
						</td>\n
						<td align='center' class='textHeaderDark'>
							Showing Rows " . (($num_rows*($_REQUEST["page"]-1))+1) . " to " . ((($total_rows < $num_rows) || ($total_rows < ($num_rows*$_REQUEST["page"]))) ? $total_rows : ($num_rows*$_REQUEST["page"])) . " of $total_rows [$url_page_select]
						</td>\n
						<td align='right' class='textHeaderDark'>
							<strong>"; if (($_REQUEST["page"] * $num_rows) < $total_rows) { $nav .= "<a class='linkOverDark' href='configstore_devices.php?page=" . ($_REQUEST["page"]+1) . ($account != '' ? "&account=$account" : '') . "'>"; } $nav .= "Next"; if (($_REQUEST["page"] * $num_rows) < $total_rows) { $nav .= "</a>"; } $nav .= " &gt;&gt;</strong>
						</td>\n
					</tr>
				</table>
			</td>
		</tr>\n";

	print $nav;

        $display_text = array(
		"space" => array("", ""),
                "hostname" => array("Hostname", "ASC"),
		"" => array("Configs", ""),
                "ipaddress" => array("IP Address", "DESC"),
		"directory" => array("Directory", "ASC"),
                "lastbackup" => array("Backup Time", "DESC"),
                "lastchange" => array("Last Change", "DESC"),
                "username" => array("Changed By", "ASC"),
                "enabled" => array("Enabled", "ASC"));

        html_header_sort_checkbox($display_text, $_REQUEST["sort_column"], $_REQUEST["sort_direction"]);

	$c=0;
	$i=0;
	foreach ($result as $row) {
		form_alternate_row_color($colors["alternate"],$colors["light"],$i, 'line' . $row["id"]); $i++;

		$total = db_fetch_cell("SELECT count(device) FROM plugin_configstore_backups WHERE device=" . $row['id']);

                form_selectable_cell($row['backupresult'] == '0' ? '<img border=0 src="images/green-ball.png" height=10 width=10 alt="Backup Result" title="Backup OK" /></img>&nbsp;' : '<span style="white-space:nowrap"><image border=0 src="images/red-ball.png" height=10 width=10 alt="Backup Result" title="Backup Failed" /></img>&nbsp;' . '<a href="configstore_devices.php?action=viewdebug&id=' . $row['id'] . '">' . '<img border=0 src="images/debug.png" height=10 width=10 alt="Debug Info" title="Debug Info" /></img></a></span>', $row['id']);
                form_selectable_cell('<a href="configstore_devices.php?&action=edit&id=' . $row['id'] . '">' . $row['hostname'] . '</a>', $row['id']);
                form_selectable_cell("<a href=configstore_devices.php?action=viewconfig&id=" . $row['id'] . ">Current</a> - <a href=configstore_backups.php?device=" . $row['id'] . ">Backups ($total)</a>", $row['id']);
                form_selectable_cell($row['ipaddress'], $row['id']);
                form_selectable_cell($row['directory'], $row['id']);
                form_selectable_cell(($row['lastbackup'] < 1 ? '' : date('M j Y H:i:s', $row['lastbackup'])), $row['id']);
                form_selectable_cell(($row['lastchange'] < 1 ? '' : date('M j Y H:i:s', $row['lastchange'])), $row['id']);
                form_selectable_cell($row['username'], $row['id']);
                form_selectable_cell(($row['enabled'] == 'on' ? 'Yes' : '<font color=red><b>No</b></font>'), $row['id']);
                form_checkbox_cell($row["hostname"], $row["id"]);
		form_end_row();
	}
	print $nav;

	html_end_box(false);
	draw_actions_dropdown($ds_actions);

	print "&nbsp;&nbsp;&nbsp;<a href='configstore_devices.php?action=edit'><img border=0 src='" . $config['url_path'] . "images/button_add.gif'></a>";

}
