<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2007 The Cacti Group                                      |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/


chdir('../../');

include("./include/auth.php");

include_once($config['base_path'] . '/plugins/configstore/functions.php');
include_once($config['base_path'] . '/plugins/configstore/include/logger.class.php');

global $log;
$log = new Logging();

$site_actions = array(
	1 => "Delete",
	2 => "Duplicate",
);

$action = "";
if (isset($_POST['action'])) {
	$action = $_POST['action'];
} else if (isset($_GET['action'])) {
	$action = $_GET['action'];
}

$site_edit = array (
	"site_id" => array(
		"method" => "textbox",
		"friendly_name" => "Site ID",
		"description" => "ID for this site",
		"value" => "|arg1:site_id|",
		"max_length" => "12"
		),
        "name" => array(
                "method" => "textbox",
                "friendly_name" => "Name",
                "description" => "Give this site a meaningful name that will be displayed.",
                "value" => "|arg1:name|",
                "max_length" => "128"
                ),
        "address" => array(
                "method" => "textbox",
                "friendly_name" => "Address",
                "description" => "Provide the street address to this site.",
                "value" => "|arg1:address|",
		"max_length" => "128"
                ),
	"suite" => array(
		"method" => "textbox",
		"friendly_name" => "suite",
		"description" => "Provide the suite number, if this site is in a multi unit building.",
		"value" => "|arg1:suite|",
		"max_length" => "12",
		),
	"city" => array(
		"method" => "textbox",
		"friendly_name" => "City",
		"description" => "Provide the city this site is in.",
		"value" => "|arg1:city|",
		"max_length" => "128"
		),
	"state" => array(
		"method" => "textbox",
		"friendly_name" => "State",
		"description" => "Provide the state or province, etc. that this site is in.",
		"value" => "|arg1:state|",
		"max_length" => "128"
		),
	"zip" => array(
		"method" => "textbox",
		"friendly_name" => "Zip Code",
		"description" => "Provide the zip code for the are this site is in.",
		"value" => "|arg1:zip|",
		"max_length" => "12",
		),
	"facility_contact_name" => array(
                "method" => "textbox",
                "friendly_name" => "Facility Contact Name",
                "description" => "Provide a contact name for the facility.",
                "value" => "|arg1:facility_contact_name|",
                "max_length" => "128"
                ),
        "facility_contact_number" => array(
                "method" => "textbox",
                "friendly_name" => "Facility Contact Number",
                "description" => "Provide a contact phone number for the facility.",
                "value" => "|arg1:facility_contact_number|",
                "max_length" => "64"
                ),
        "facility_contact_email" => array(
                "method" => "textbox",
                "friendly_name" => "Facility Contact Email",
                "description" => "Provide a contact email address for the facility.",
                "value" => "|arg1:facility_contact_email|",
                "max_length" => "128"
                ),
        "technical_contact_name" => array(
                "method" => "textbox",
                "friendly_name" => "Technical Contact Name",
                "description" => "Provide a technical contact name for the facility.",
                "value" => "|arg1:technical_contact_name|",
                "max_length" => "128"
                ),
        "technical_contact_number" => array(
                "method" => "textbox",
                "friendly_name" => "Technical Contact Number",
                "description" => "Provide a technical contact phone number for the facility.",
                "value" => "|arg1:technical_contact_number|",
                "max_length" => "64"
                ),
        "technical_contact_email" => array(
                "method" => "textbox",
                "friendly_name" => "Technical Contact Email",
                "description" => "Provide a technical contact email address for the facility.",
                "value" => "|arg1:technical_contact_email|",
                "max_length" => "128"
                ),
	"site_information" => array(
		"method" => "textarea",
		"friendly_name" => "Site Information",
		"description" => "This field is for any information you would like to add, which is specific to this site.",
                "textarea_rows" => "3",
                "textarea_cols" => "80",
		"value" => "|arg1:site_information|",
		"max_length" => "255"
		),
        "id" => array(
                "method" => "hidden_zero",
                "value" => "|arg1:id|"
                ),
        "action" => array(
                "method" => "hidden_zero",
                "value" => "edit"
                )
        );

switch ($action) {
	case 'actions':
		actions_site ();
		break;
	case 'save':
		save_site ();
		break;
	case 'edit':
		include_once("./include/top_header.php");
		display_tabs ();
		edit_site ();
		include_once("./include/bottom_footer.php");
		break;
	default:
		include_once("./include/top_header.php");
		display_tabs ();
		show_site ();
		include_once("./include/bottom_footer.php");
		break;
}

function display_tabs () {
        /* draw the categories tabs on the top of the page */
        print "<table class='tabs' width='100%' cellspacing='0' cellpadding='3' align='center'><tr>\n";
        print "<td bgcolor='silver' nowrap='nowrap' width='" . (strlen('Sites') * 9) . "' align='center' class='tab'>
                        <span class='textHeader'><a href='configstore_sites.php'>Sites</a></span>
                        </td>\n
                        <td width='1'></td>\n";
        print "<td bgcolor='#DFDFDF' nowrap='nowrap' width='" . (strlen('Devices') * 9) . "' align='center' class='tab'>
                        <span class='textHeader'><a href='configstore_devices.php'>Devices</a></span>
                        </td>\n
                        <td width='1'></td>\n";
        print "<td bgcolor='#DFDFDF' nowrap='nowrap' width='" . (strlen('Backups') * 9) . "' align='center' class='tab'>
                        <span class='textHeader'><a href='configstore_backups.php?device='>Backups</a></span>
                        </td>\n
                        <td width='1'></td>\n";
        print "<td bgcolor='#DFDFDF' nowrap='nowrap' width='" . (strlen('Accounts') * 9) . "' align='center' class='tab'>
                        <span class='textHeader'><a href='configstore_accounts.php'>Accounts</a></span>
                        </td>\n
                        <td width='1'></td>\n";
        print "<td bgcolor='#DFDFDF' nowrap='nowrap' width='" . (strlen('Compare') * 9) . "' align='center' class='tab'>
                        <span class='textHeader'><a href='configstore_compare.php'>Compare</a></span>
                        </td>\n
                        <td width='1'></td>\n";
        print "<td></td>\n</tr></table>\n";
}

function actions_site () {
	global $colors, $site_actions, $config;
	if (isset($_POST["selected_items"])) {
		$selected_items = unserialize(stripslashes($_POST["selected_items"]));
		if ($_POST["drp_action"] == "1") { /* delete */

			for ($i=0; $i<count($selected_items); $i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */
				db_execute("DELETE FROM plugin_configstore_sites WHERE id = " . $selected_items[$i]);
			}
		} elseif ($_POST["drp_action"] == "2") { /* duplicate */
                        for ($i=0;($i<count($selected_items));$i++) {
                                /* ================= input validation ================= */
                                input_validate_input_number($selected_items[$i]);
                                /* ==================================================== */

                                duplicate_site($selected_items[$i], $i, $_POST["title_format"]);
                        }
                }

		header("Location: configstore_sites.php");
		exit;
	}


	/* setup some variables */
	$site_list = "";
	$i = 0;

	/* loop through each of the sites selected on the previous page and get more info about them */
	while (list($var,$val) = each($_POST)) {
		if (ereg("^chk_([0-9]+)$", $var, $matches)) {
			/* ================= input validation ================= */
			input_validate_input_number($matches[1]);
			/* ==================================================== */

			$site_list .= "<li>" . db_fetch_cell("SELECT name FROM plugin_configstore_sites WHERE id=" . $matches[1]) . "<br>";
			$site_array[$i] = $matches[1];
		}
		$i++;
	}

	include_once("./include/top_header.php");

	html_start_box("<strong>" . $site_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "3", "center", "");

	print "<form action='configstore_sites.php' method='post'>\n";

	if ($_POST["drp_action"] == "1") { /* Delete */
		print "	<tr>
				<td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
					<p>To delete the following sites, press the \"yes\" button below.</p>
					<p><ul>$site_list</ul></p>
				</td>
				</tr>";
	} elseif ($_POST["drp_action"] == "2") { /* duplicate */
                print " <tr>
                                <td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
                                        <p>When you click save, the following site will be duplicated. You may optionally change the description for the new site.  Otherwise, do not change value below and the original name will be replicated with a new suffix.</p>
                                        <p><ul>$site_list</ul></p>
                                        <p><strong>Site Prefix:</strong><br>"; form_text_box("title_format", "<site_id> (1)", "", "255", "30", "text"); print "</p>
                                </td>
                        </tr>\n
             ";
        }

	if (!isset($site_list)) {
                print "<tr><td bgcolor='#" . $colors["form_alternate1"]. "'><span class='textError'>You must select at least one site.</span></td></tr>\n";
                $save_html = "";
        }else{
		$save_html = "<input type='image' src='" . $config['url_path'] . "images/button_yes.gif' alt='Save' align='absmiddle'>";
        }

        print " <tr>
                        <td colspan='2' align='right' bgcolor='#eaeaea'>
                                <input type='hidden' name='action' value='actions'>
                                <input type='hidden' name='selected_items' value='" . (isset($site_array) ? serialize($site_array) : '') . "'>
                                <input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
                                <a href='configstore_sites.php'><img src='" . $config['url_path'] . "images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
                                $save_html
                        </td>
                </tr>
        ";

        html_end_box();

        include_once("./include/bottom_footer.php");
}

function save_site() {
	global $log;
	/* ================= input validation ================= */
        input_validate_input_number(get_request_var_post("id"));
        /* ==================================================== */

        if (isset($_POST['id'])) {
		$id = $_POST["id"];
        } else {
                $id = '';
        }

	$site_id = $_POST["site_id"];
	$name = $_POST["name"];
	$address = $_POST["address"];
	$suite = $_POST["suite"];
	$city = $_POST["city"];
	$state = $_POST["state"];
	$zip = $_POST["zip"];
	$facility_contact_name = $_POST["facility_contact_name"];
	$facility_contact_number = $_POST["facility_contact_number"];
	$facility_contact_email = $_POST["facility_contact_email"];
	$technical_contact_name = $_POST["technical_contact_name"];
	$technical_contact_number = $_POST["technical_contact_number"];
	$technical_contact_email = $_POST["technical_contact_email"];
	$site_information = $_POST["site_information"];

	if ( (empty($name)) || (empty($address)) ) {
		raise_message(2);
	}

	$save["id"] = $id;
	$save["site_id"] = $site_id;
	$save["name"] = $name;
	$save["address"] = $address;
	$save["suite"] = $suite;
	$save["city"] = $city;
	$save["state"] = $state;
	$save["zip"] = $zip;
	$save["facility_contact_name"] = $facility_contact_name;
	$save["facility_contact_number"] = $facility_contact_number;
	$save["facility_contact_email"] = $facility_contact_email;
	$save["technical_contact_name"] = $technical_contact_name;
	$save["technical_contact_number"] = $technical_contact_number;
	$save["technical_contact_email"] = $technical_contact_email;
	$save["site_information"] = $site_information;

	$id = sql_save($save, "plugin_configstore_sites", "id");

	if (is_error_message()) {
		header ("Location: configstore_sites.php?action=edit&id=" . (empty($id) ? $_POST["id"] : $id));
		exit;
	}
	header("Location: configstore_sites.php");
	exit;
}

function edit_site () {
	global $site_edit, $colors;

        /* ================= input validation ================= */
        input_validate_input_number(get_request_var_post("id"));
        /* ==================================================== */

        # fetch the current site record
	$site = array();
	if (!empty($_GET["id"])) {
        	$site = db_fetch_row("SELECT * FROM plugin_configstore_sites WHERE id=" . $_GET["id"], FALSE);
		$header_label = "[edit: " . $site["name"] . "]";
	} else {
		$header_label = "[new]";
	}

	html_start_box("<strong>Site:</strong> $header_label", "100%", $colors["header"], "3", "center", "");
	draw_edit_form(array(
		"config" => array("form_name" => "chk"),
		"fields" => inject_form_variables($site_edit, $site)
		)
	);

	html_end_box();
	form_save_button("configstore_sites.php");
}

function configstore_get_sites(&$sql_where, $num_rows, $apply_limits = TRUE) {
        global $log;
        if ($_REQUEST["filter"] != "") {
                $sql_where = " WHERE (plugin_configstore_sites.site_id LIKE '%%" . $_REQUEST["filter"] . "%%' OR
			plugin_configstore_sites.name LIKE '%%" . $_REQUEST["filter"] . "%%' OR
			plugin_configstore_sites.address LIKE '%%" . $_REQUEST["filter"] . "%%' OR
			plugin_configstore_sites.city LIKE '%%" . $_REQUEST["filter"] . "%%' OR
			plugin_configstore_sites.state LIKE '%%" . $_REQUEST["filter"] . "%%' OR
			plugin_configstore_sites.zip LIKE '%%" . $_REQUEST["filter"] . "%%' OR
			plugin_configstore_sites.facility_contact_name LIKE '%%" . $_REQUEST["filter"] . "%%' OR
			plugin_configstore_sites.facility_contact_number LIKE '%%" . $_REQUEST["filter"] . "%%' OR
			plugin_configstore_sites.facility_contact_email LIKE '%%" . $_REQUEST["filter"] . "%%' OR
			plugin_configstore_sites.technical_contact_name LIKE '%%" . $_REQUEST["filter"] . "%%' OR
			plugin_configstore_sites.technical_contact_number LIKE '%%" . $_REQUEST["filter"] . "%%' OR
			plugin_configstore_sites.technical_contact_email LIKE '%%" . $_REQUEST["filter"] . "%%')";
        }

        $query_string = "SELECT * FROM plugin_configstore_sites $sql_where ORDER BY " . $_REQUEST["sort_column"] . " " . $_REQUEST["sort_direction"];

        if ($apply_limits) {
                $query_string .= " LIMIT " . ($num_rows*($_REQUEST["page"]-1)) . "," . $num_rows;
        }

        return db_fetch_assoc($query_string);
}

function show_site () {
	global $action, $colors, $config, $site_actions;

        /* ================= input validation ================= */
        input_validate_input_number(get_request_var_request("page"));
        input_validate_input_number(get_request_var_request("rows"));
        /* ==================================================== */

        /* clean up search filter */
        if (isset($_REQUEST["filter"])) {
                $_REQUEST["filter"] = sanitize_search_string(get_request_var("filter"));
        }

        /* clean up sort_column */
        if (isset($_REQUEST["sort_column"])) {
                $_REQUEST["sort_column"] = sanitize_search_string(get_request_var("sort_column"));
        }

        /* clean up search string */
        if (isset($_REQUEST["sort_direction"])) {
                $_REQUEST["sort_direction"] = sanitize_search_string(get_request_var("sort_direction"));
        }

        /* if the user pushed the 'clear' button */
        if (isset($_REQUEST["clear_x"])) {
                kill_session_var("sess_configstore_site_current_page");
                kill_session_var("sess_configstore_site_filter");
                kill_session_var("sess_configstore_site_rows");
                kill_session_var("sess_configstore_site_sort_column");
                kill_session_var("sess_configstore_site_sort_direction");

                unset($_REQUEST["page"]);
                unset($_REQUEST["filter"]);
                unset($_REQUEST["rows"]);
                unset($_REQUEST["sort_column"]);
                unset($_REQUEST["sort_direction"]);
        }

        /* remember these search fields in session vars so we don't have to keep passing them around */
	load_current_session_value("page", "sess_configstore_site_current_page", "1");
	load_current_session_value("filter", "sess_configstore_site_filter", "");
	load_current_session_value("rows", "sess_configstore_site_rows", "-1");
	load_current_session_value("sort_column", "sess_configstore_site_sort_column", "site_id");
	load_current_session_value("sort_direction", "sess_configstore_site_sort_direction", "ASC");


        if ($_REQUEST["rows"] == -1) {
                $num_rows = 30;
        }elseif ($_REQUEST["rows"] == -2) {
                $num_rows = 999999;
        }else{
                $num_rows = $_REQUEST["rows"];
        }

        define("MAX_DISPLAY_PAGES", 21);

        // START Device filter
        html_start_box("<strong>Configstore Site Filters</strong>", "100%", $colors["header"], "3", "center", "configstore_sites.php?action=edit");
        configstore_generic_filter();
        html_end_box();
        // END Device filter

        $sql_where = "";
        $result = configstore_get_sites($sql_where, $num_rows);

	$total_rows = db_fetch_cell("SELECT COUNT(*) FROM plugin_configstore_sites $sql_where");
        $url_page_select = get_page_list($_REQUEST["page"], MAX_DISPLAY_PAGES, $num_rows, $total_rows, "configstore_sites.php?");

	html_start_box("", "100%", $colors["header"], "4", "center", "");
	$nav = "<tr bgcolor='#" . $colors["header"] . "'>
			<td colspan='11'>
				<table width='100%' cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td align='left' class='textHeaderDark'>
							<strong>&lt;&lt; "; if ($_REQUEST["page"] > 1) { $nav .= "<a class='linkOverDark' href='configstore_sites.php?page=" . ($_REQUEST["page"]-1) . "'>"; } $nav .= "Previous"; if ($_REQUEST["page"] > 1) { $nav .= "</a>"; } $nav .= "</strong>
						</td>\n
						<td align='center' class='textHeaderDark'>
							Showing Rows " . (($num_rows*($_REQUEST["page"]-1))+1) . " to " . ((($total_rows < $num_rows) || ($total_rows < ($num_rows*$_REQUEST["page"]))) ? $total_rows : ($num_rows*$_REQUEST["page"])) . " of $total_rows [$url_page_select]
						</td>\n
						<td align='right' class='textHeaderDark'>
							<strong>"; if (($_REQUEST["page"] * $num_rows) < $total_rows) { $nav .= "<a class='linkOverDark' href='configstore_sites.php?page=" . ($_REQUEST["page"]+1) . "'>"; } $nav .= "Next"; if (($_REQUEST["page"] * $num_rows) < $total_rows) { $nav .= "</a>"; } $nav .= " &gt;&gt;</strong>
						</td>\n
					</tr>
				</table>
			</td>
		</tr>\n";

	print $nav;

        $display_text = array(
		"site_id" => array("Site ID", "ASC"),
                "name" => array("Name", "ASC"),
		"address" => array("Address", "ASC"),
		"suite" => array("Suite", "ASC"),
		"city" => array("City", "ASC"),
		"state" => array("State", "ASC"),
		"zip" => array("Zip", "ASC"),
		"facility_contact_name" => array("Facility Contact Name", "ASC"),
		"facility_contact_number" => array("Facility Contact Number", "ASC"),
                "count" => array("Devices", "DESC"));

        html_header_sort_checkbox($display_text, $_REQUEST["sort_column"], $_REQUEST["sort_direction"]);

	$count=0;
	$i=0;
	foreach ($result as $row) {
		form_alternate_row_color($colors["alternate"],$colors["light"],$i, 'line' . $row["id"]); $i++;

                $count = db_fetch_cell("SELECT count(site) FROM plugin_configstore_devices WHERE site = " . $row['id']);

		form_selectable_cell('<a href=configstore_sites.php?&action=edit&id=' . $row['id'] . '>' . $row['site_id'] . '</a>', $row["id"]);
		form_selectable_cell('<a href=configstore_sites.php?&action=edit&id=' . $row['id'] . '>' . $row['name'] . '</a>', $row["id"]);
		form_selectable_cell($row["address"], $row["id"]);
		form_selectable_cell($row["suite"], $row["id"]);
		form_selectable_cell($row["city"], $row["id"]);
		form_selectable_cell($row["state"], $row["id"]);
		form_selectable_cell($row["zip"], $row["id"]);
		form_selectable_cell($row["facility_contact_name"], $row["id"]);
		form_selectable_cell($row["facility_contact_number"], $row["id"]);
		form_selectable_cell('<a href=configstore_devices.php?site=' . $row['id'] . '>' . $count . '</a>', $row["id"]);
		form_checkbox_cell($row["name"], $row["id"]);
		form_end_row();
	}
	print $nav;

	html_end_box(false);
	draw_actions_dropdown($site_actions);

	print "&nbsp;&nbsp;&nbsp;<a href='configstore_sites.php?action=edit'><img border=0 src='" . $config['url_path'] . "images/button_add.gif'></a>";

}

function duplicate_site ($id, $dup_id, $site_id) {
        if (!empty($id)) {
                $site = db_fetch_row("SELECT * FROM plugin_configstore_sites WHERE id=$id");

                /* create new site */
                $save["id"] = 0;

                if (substr_count($name, "<site_id>")) {
                        $save["site_id"] = $site["site_id"] . "(1)";
                }else{
                        $save["site_id"] = $name . "(" . $dup_id . ")";
                }

		$save["name"] = $name;
        	$save["address"] = $address;
		$save["suite"] = $suite;
		$save["city"] = $city;
		$save["state"] = $state;
		$save["zip"] = $zip;
        	$save["facility_contact_name"] = $facility_contact_name;
		$save["facility_contact_number"] = $facility_contact_number;
		$save["facility_contact_email"] = $facility_contact_email;
        	$save["technical_contact_name"] = $technical_contact_name;
		$save["technical_contact_number"] = $technical_contact_number;
		$save["technical_contact_email"] = $technical_contact_email;
        	$save["site_information"] = $site_information;

                $id = sql_save($save, "plugin_configstore_sites", array("id"));
        }
}
