<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2007 The Cacti Group                                      |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/


chdir('../../');

include("./include/auth.php");

include_once($config['base_path'] . '/plugins/configstore/functions.php');
include_once($config['base_path'] . '/plugins/configstore/include/logger.class.php');

global $log;
$log = new Logging();

$template_actions = array(1 => 'Delete', 2 => 'Duplicate');

$action = "";
if (isset($_POST['action'])) {
	$action = $_POST['action'];
} else if (isset($_GET['action'])) {
	$action = $_GET['action'];
}

$template_edit = array (
        "name" => array(
                "method" => "textbox",
                "friendly_name" => "Name",
                "description" => "Give this template a meaningful name that will be displayed.",
                "value" => "|arg1:name|",
                "max_length" => "64"
                ),
        "config" => array(
                "method" => "textarea",
                "friendly_name" => "Configuration Template",
                "description" => "The common configuration items for a particular device, deployement, purpose, etc.",
                "value" => "|arg1:config|",
                "textarea_rows" => "36",
                "textarea_cols" => "120"
                ),
        "id" => array(
                "method" => "hidden_zero",
                "value" => "|arg1:id|"
                ),
        "action" => array(
                "method" => "hidden_zero",
                "value" => "edit"
                )
        );

switch ($action) {
	case 'viewconfig':
		view_config_template();
		break;
	case 'actions':
		actions_templates();
		break;
	case 'save':
		save_templates ();
		break;
	case 'edit':
		include_once("./include/top_header.php");
		edit_templates();
		include_once("./include/bottom_footer.php");
		break;
	default:
		include_once("./include/top_header.php");
		show_templates ();
		include_once("./include/bottom_footer.php");
		break;
}

function view_config_template() {
	global $colors;

	$templatepath = "templates";

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("id"));
	/* ==================================================== */
	$template = array();
	if (!empty($_GET["id"])) {
		$template = db_fetch_row("SELECT * FROM plugin_configstore_templates WHERE id=" . $_GET["id"], FALSE);
	}

	if (isset($template['id'])) {
		include_once("./include/top_header.php");
		html_start_box("", "98%", $colors["header"], "4", "center", "");
		form_alternate_row_color($colors["alternate"],$colors["light"],0);
		print '<td><h2>Configuration Template: ' . $template['name'] . '<br><br>';
		print 'Last Updated: ' . date('M j Y H:i:s', $template['lastchange']) . '<br>';
		print 'File: ' . $templatepath . '/' . $template['filename'];
		print '</h1><textarea rows=36 cols=120>';
		print $template['config'];
		print '</textarea></td></tr>';
		html_end_box(false);
	} else {
		header("Location: configstore_devices.php");
		exit;
	}
}

function actions_templates () {
        global $colors, $template_actions, $config, $log;
        if (isset($_POST["selected_items"])) {
                $selected_items = unserialize(stripslashes($_POST["selected_items"]));
                if ($_POST["drp_action"] == "1") { /* delete */

                        for ($i=0; $i<count($selected_items); $i++) {
                                /* ================= input validation ================= */
                                input_validate_input_number($selected_items[$i]);
                                /* ==================================================== */
				$delete_from_dir = delete_from_dir($selected_items[$i]);
				if ($delete_from_dir) {
					db_execute("DELETE FROM plugin_configstore_templates WHERE id = " . $selected_items[$i]);
				} else {
				}
                        }
                } elseif ($_POST["drp_action"] == "2") { /* duplicate */
                        for ($i=0;($i<count($selected_items));$i++) {
                                /* ================= input validation ================= */
                                input_validate_input_number($selected_items[$i]);
                                /* ==================================================== */

                                duplicate_template($selected_items[$i], $i, $_POST["title_format"]);
                        }
                }

                header("Location: configstore_templates.php");
                exit;
        }


        /* setup some variables */
        $template_list = "";
        $i = 0;

        /* loop through each of the templates selected on the previous page and get more info about them */
        while (list($var,$val) = each($_POST)) {
                if (ereg("^chk_([0-9]+)$", $var, $matches)) {
                        /* ================= input validation ================= */
                        input_validate_input_number($matches[1]);
                        /* ==================================================== */

                        $template_list .= "<li>" . db_fetch_cell("SELECT name FROM plugin_configstore_templates WHERE id=" . $matches[1]) . "<br>";
                        $template_array[$i] = $matches[1];
                }
                $i++;
        }

        include_once("./include/top_header.php");
        
        html_start_box("<strong>" . $template_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "3", "center", "");

        print "<form action='configstore_templates.php' method='post'>\n";

        if ($_POST["drp_action"] == "1") { /* Delete */
                print " <tr>
                                <td colspan='2' class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
                                        <p>To delete the following templates, press the \"yes\" button below.</p>
                                        <p><ul>$template_list</ul></p>
                                </td>
                                </tr>";
        } elseif ($_POST["drp_action"] == "2") { /* duplicate */
                print " <tr>
                                <td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
                                        <p>When you click save, the following templates will be duplicated. You may optionally change the description for the new template.  Otherwise, do not change value below and the original name will be replicated with a new suffix.</p>
                                        <p><ul>$template_list</ul></p>
                                        <p><strong>Template Prefix:</strong><br>"; form_text_box("title_format", "<name>", "", "255", "30", "text"); print "</p>
                                </td>
                        </tr>\n
              ";
        }

        if (!isset($template_list)) {
                print "<tr><td bgcolor='#" . $colors["form_alternate1"]. "'><span class='textError'>You must select at least one template.</span></td></tr>\n";
                $save_html = "";
        }else{
        }
		$save_html = "<input type='image' src='" . $config['url_path'] . "images/button_yes.gif' alt='Save' align='absmiddle'>";

        print " <tr>
                        <td colspan='2' align='right' bgcolor='#eaeaea'>
                                <input type='hidden' name='action' value='actions'>
                                <input type='hidden' name='selected_items' value='" . (isset($template_array) ? serialize($template_array) : '') . "'>
                                <input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
                                <a href='configstore_templates.php'><img src='" . $config['url_path'] . "images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
                                $save_html
                        </td>
                </tr>
                ";


        html_end_box();
        include_once("./include/bottom_footer.php");
}


function save_templates () {
	global $log;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var_post("id"));
	/* ==================================================== */

	if (isset($_POST['id'])) {
		$save['id'] = $_POST['id'];
	} else {
		$save['id'] = '';
	}

	$old_filename = db_fetch_cell("SELECT filename FROM plugin_configstore_templates WHERE id=" . $_POST['id']);
	$save['name'] = sql_sanitize($_POST['name']);
	$save['config'] = sql_sanitize($_POST['config']);
	$save['username'] = db_fetch_cell("SELECT username FROM user_auth WHERE id=" . $_SESSION["sess_user_id"]);
	$save['lastchange'] = time();
	$date = date("Y-m-d-Hi");
	$save['filename'] = $_POST['name'] . "-" . $date . ".cfg";
	$save_to_dir;

	$id = sql_save($save, "plugin_configstore_templates", "id");

	if (is_error_message()) {
		header("Location: configstore_templates.php?action=edit&id=" . (empty($id) ? $_POST["id"] : $id));
		exit;
	} else {
		$save_to_dir = save_to_dir($save['config'], $save['filename'], $old_filename);
	}

	header("Location: configstore_templates.php");
	exit;

}

function edit_templates () {
	global $template_edit, $colors;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("id"));
	/* ==================================================== */

	$template = array();
	if (!empty($_GET["id"])) {
		$template = db_fetch_row("SELECT * FROM plugin_configstore_templates WHERE id=" . $_GET["id"], FALSE);
		$header_label = "[edit: " . $template["name"] . "]";
	}else{
		$header_label = "[new]";
	}

	html_start_box("<strong>Template:</strong> $header_label", "98%", $colors["header"], "3", "center", "");
	draw_edit_form(array(
		"config" => array("form_name" => "chk"),
		"fields" => inject_form_variables($template_edit, $template)
		)
	);

	html_end_box();
	form_save_button("configstore_templates.php");
}

function configstore_get_templates(&$sql_where, $num_rows, $apply_limits = TRUE) {
	global $log;
        if ($_REQUEST["filter"] != "") {
                $sql_where = " WHERE (plugin_configstore_templates.name LIKE '%%" . $_REQUEST["filter"] . "%%')";
        }

        $query_string = "SELECT * FROM plugin_configstore_templates $sql_where ORDER BY " . $_REQUEST["sort_column"] . " " . $_REQUEST["sort_direction"];

        if ($apply_limits) {
                $query_string .= " LIMIT " . ($num_rows*($_REQUEST["page"]-1)) . "," . $num_rows;
        }

        return db_fetch_assoc($query_string);
}

function show_templates () {
	global $action, $colors, $config, $template_actions, $result, $log;

	/* ================= input validation ================= */
      	input_validate_input_number(get_request_var_request("page"));
      	input_validate_input_number(get_request_var_request("rows"));
      	/* ==================================================== */

	/* clean up search filter */
        if (isset($_REQUEST["filter"])) {
                $_REQUEST["filter"] = sanitize_search_string(get_request_var("filter"));
        }

        /* clean up sort_column */
        if (isset($_REQUEST["sort_column"])) {
                $_REQUEST["sort_column"] = sanitize_search_string(get_request_var("sort_column"));
        }

        /* clean up search string */
        if (isset($_REQUEST["sort_direction"])) {
                $_REQUEST["sort_direction"] = sanitize_search_string(get_request_var("sort_direction"));
        }

        /* if the user pushed the 'clear' button */
        if (isset($_REQUEST["clear_x"])) {
                kill_session_var("sess_configstore_templates_current_page");
                kill_session_var("sess_configstore_templates_filter");
                kill_session_var("sess_configstore_templates_rows");
                kill_session_var("sess_configstore_templates_sort_column");
                kill_session_var("sess_configstore_templates_sort_direction");

                unset($_REQUEST["page"]);
                unset($_REQUEST["filter"]);
                unset($_REQUEST["rows"]);
                unset($_REQUEST["sort_column"]);
                unset($_REQUEST["sort_direction"]);
        }

        /* remember these search fields in session vars so we don't have to keep passing them around */
        load_current_session_value("page", "sess_configstore_templates_current_page", "1");
        load_current_session_value("filter", "sess_configstore_templates_filter", "");
        load_current_session_value("rows", "sess_configstore_templates_rows", "-1");
        load_current_session_value("sort_column", "sess_configstore_templates_sort_column", "name");
        load_current_session_value("sort_direction", "sess_configstore_templates_sort_direction", "ASC");

        if ($_REQUEST["rows"] == -1) {
                $num_rows = 30;
        }elseif ($_REQUEST["rows"] == -2) {
                $num_rows = 999999;
        }else{
                $num_rows = $_REQUEST["rows"];
        }

	define("MAX_DISPLAY_PAGES", 21);
	$total_rows = db_fetch_cell("SELECT COUNT(*) FROM plugin_configstore_templates");
	$url_page_select = get_page_list($_REQUEST["page"], MAX_DISPLAY_PAGES, $num_rows, $total_rows, "configstore_templates.php?");

	// START Device filter
        html_start_box("<strong>Configstore Template Filters</strong>", "98%", $colors["header"], "3", "center", "configstore_templates.php?action=edit");
        configstore_generic_filter();
        html_end_box();
	// END Device filter

        $sql_where = "";
        $result = configstore_get_templates($sql_where, $num_rows);

	html_start_box("", "98%", $colors["header"], "4", "center", "");
	$nav = "<tr bgcolor='#" . $colors["header"] . "'>
			<td colspan='11'>
				<table width='100%' cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td align='left' class='textHeaderDark'>
							<strong>&lt;&lt; "; if ($_REQUEST["page"] > 1) { $nav .= "<a class='linkOverDark' href='configstore_templates.php?page=" . ($_REQUEST["page"]-1) . "'>"; } $nav .= "Previous"; if ($_REQUEST["page"] > 1) { $nav .= "</a>"; } $nav .= "</strong>
						</td>\n
						<td align='center' class='textHeaderDark'>
							Showing Rows " . (($num_rows*($_REQUEST["page"]-1))+1) . " to " . ((($total_rows < $num_rows) || ($total_rows < ($num_rows*$_REQUEST["page"]))) ? $total_rows : ($num_rows*$_REQUEST["page"])) . " of $total_rows [$url_page_select]
						</td>\n
						<td align='right' class='textHeaderDark'>
							<strong>"; if (($_REQUEST["page"] * $num_rows) < $total_rows) { $nav .= "<a class='linkOverDark' href='configstore_templates.php?page=" . ($_REQUEST["page"]+1) . "'>"; } $nav .= "Next"; if (($_REQUEST["page"] * $num_rows) < $total_rows) { $nav .= "</a>"; } $nav .= " &gt;&gt;</strong>
						</td>\n
					</tr>
				</table>
			</td>
		</tr>\n";

	print $nav;

	$display_text = array(
		"name" => array("Name", "ASC"),
		"view" => array(" ", "ASC"),
		"" => array("Directory", "ASC"),
		"filename" => array("Filename", "ASC"),
		"lastchange" => array("Last Change", "DESC"),
		"username" => array("Changed By", "ASC"));

	html_header_sort_checkbox($display_text, $_REQUEST["sort_column"], $_REQUEST["sort_direction"]);

	$i=0;
	$templatepath = "templates";

        foreach ($result as $row) {
                form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
                print '<td><a href="configstore_templates.php?&action=edit&id=' . $row['id'] . '">' . $row['name'] . '</a></td>';
                print "<td><a href='configstore_templates.php?action=viewconfig&id=" . $row['id'] . "'>View Template</a></td>";
                print '<td>' . $templatepath . '</td>';
                print '<td>' . $row['filename'] . '</td>';
                if ($row['lastchange'] > 0) {
                        print '<td>' . date('M j Y H:i:s', $row['lastchange']) . '</td>';
                } else {
                        print '<td> </td>';
                }
                print '<td>' . $row['username'] . '</td>';

                print '<td style="' . get_checkbox_style() . '" width="1%" align="right">';
                print '<input type="checkbox" style="margin: 0px;" name="chk_' . $row["id"] . '" title="' . $row["filename"] . '"></td>';
                print "</tr>";
        }
        print $nav;

        html_end_box(false);
        draw_actions_dropdown($template_actions);

        print "&nbsp;&nbsp;&nbsp;<a href='configstore_templates.php?action=edit'><img border=0 src='" . $config['url_path'] . "images/button_add.gif'></a>";

}

function duplicate_template ($id, $dup_id, $name) {
	global $log;

        if (!empty($id)) {
                $template = db_fetch_row("SELECT * FROM plugin_configstore_templates WHERE id=$id");

                /* create new account */
                $save["id"] = 0;

                if (substr_count($name, "<name>")) {
                        $save["name"] = $template["name"] . "--dup";
                }else{
                        $save["name"] = $name . "--dup";
                }

		$date = date("Y-m-d-Hi");
                $save["filename"] = $save["name"] . "-" . $date . ".cfg";
                $save["config"] = $template["config"];
                $save["username"] = $template["username"];
		$save["lastchange"] = time();

                $id = sql_save($save, "plugin_configstore_templates", array("id"));

        	if (is_error_message()) {
               		header("Location: configstore_templates.php?action=edit&id=" . (empty($id) ? $_POST["id"] : $id));
                	exit;
        	} else {
                	$save_to_dir = save_to_dir($save['config'], $save['filename'], $old_filename);
        	}

        	if ($save_to_dir) {
        	} else {
        	}
        }
}

function save_to_dir ($config, $filename, $old_filename) {
	$backuppath = read_config_option("plugin_configstore_backup_path");
        $templatepath = "$backuppath/templates";
	
	if (!is_dir($templatepath)) {
		mkdir("$templatepath", 0777, true);
	}

	if (is_file("$templatepath/$old_filename")) {
		@unlink("$templatepath/$old_filename");
	}

	if (is_file("$templatepath/$filename")) {
		@unlink("$templatepath/$filename");
		$file = fopen("$templatepath/$filename", 'w');
                fwrite($file, $config);
                fclose($file);
	} else {
                $file = fopen("$templatepath/$filename", 'w');
                fwrite($file, $config);
                fclose($file);
	}

	if (filesize("$templatepath/$filename") > 0) {
		return true;
	} else {
		return false;
	}
}

function delete_from_dir ($id) {
	global $log;
	$fileinfo = db_fetch_row("SELECT * FROM plugin_configstore_templates WHERE id=$id");

	$filename = $fileinfo['filename'];
	$backuppath = read_config_option("plugin_configstore_backup_path");
        $templatepath = "$backuppath/templates";

	if (is_file("$templatepath/$filename")) {
		@unlink("$templatepath/$filename");
		return true;
	} else {
		return false;
	}
}
		
